local VERSION = "0.11.1" -- ./anselme.can:1
local dissallowedVariable = "%{%}%§%>%<%(%)%~%+%-%*%/%%%=%?%!%&%|%:%^%,%@%s%.%#\"" -- ./anselme.can:6
local pvariable -- ./anselme.can:7
pvariable = ("[^%s%%d][^%s]*"):format(dissallowedVariable, dissallowedVariable) -- ./anselme.can:7
local binopPriority -- ./anselme.can:10
binopPriority = { -- ./anselme.can:10
[","] = 0, -- ./anselme.can:11
[":"] = 1, -- ./anselme.can:12
["|"] = 2, -- ./anselme.can:13
["&"] = 3, -- ./anselme.can:14
["<"] = 4, -- ./anselme.can:15
[">"] = 4, -- ./anselme.can:15
["<="] = 4, -- ./anselme.can:15
[">="] = 4, -- ./anselme.can:15
["!="] = 4, -- ./anselme.can:15
["="] = 4, -- ./anselme.can:15
["+"] = 5, -- ./anselme.can:16
["-"] = 5, -- ./anselme.can:16
["*"] = 6, -- ./anselme.can:17
["/"] = 6, -- ./anselme.can:17
["//"] = 6, -- ./anselme.can:17
["%"] = 6, -- ./anselme.can:17
["^"] = 8 -- ./anselme.can:18
} -- ./anselme.can:18
local unopPriority -- ./anselme.can:20
unopPriority = { -- ./anselme.can:20
["!"] = 7, -- ./anselme.can:21
["-"] = 7, -- ./anselme.can:21
["?"] = 9 -- ./anselme.can:22
} -- ./anselme.can:22
local expression, eval, evalBool, evalAddress, luaToAns, findVariable, lookupVariable, runFunction, formatText, sendEvent, parse, run, tryPotentialFunction, pushTags, readable, evalList, evalNoParagraph, defineVariable, runChildren, step, evalFlatListNoParagraph, insertAnselmsScriptsFromDirectory -- ./anselme.can:27
parse = function(context, code, origin, temporary) -- ./anselme.can:30
if origin == nil then origin = "a unnamed chunk" end -- ./anselme.can:30
local root -- ./anselme.can:31
root = context["root"] -- ./anselme.can:31
local parent -- ./anselme.can:32
parent = context -- ./anselme.can:32
local parentParagraph -- ./anselme.can:33
parentParagraph = (parent["paragraph"] or parent["type"] == "root") and parent or parent["parentParagraph"] -- ./anselme.can:33
local lastParsed = nil -- ./anselme.can:34
local lastLineEmpty = false -- ./anselme.can:35
local indent = 0 -- ./anselme.can:36
local lineno = 0 -- ./anselme.can:37
local skipChildren = false -- ./anselme.can:38
for l in (code .. "\
"):gmatch("([^\
]*)\
") do -- ./anselme.can:39
do -- ./anselme.can:39
lineno = lineno + (1) -- ./anselme.can:40
local tabs, line -- ./anselme.can:43
tabs, line = l:match("^(\9*)(.*)$") -- ./anselme.can:43
local level -- ./anselme.can:44
level = # tabs -- ./anselme.can:44
if line == "" or (skipChildren and level > indent) then -- ./anselme.can:45
lastLineEmpty = true -- ./anselme.can:46
goto __CAN_continue -- ./anselme.can:47
end -- ./anselme.can:47
if skipChildren and level <= indent then -- ./anselme.can:49
skipChildren = false -- ./anselme.can:50
end -- ./anselme.can:50
if level == indent + 1 then -- ./anselme.can:54
indent = indent + (1) -- ./anselme.can:55
parent = lastParsed -- ./anselme.can:56
if parent["type"] == "paragraph" then -- ./anselme.can:57
parentParagraph = parent -- ./anselme.can:58
end -- ./anselme.can:58
if not parent["children"] then -- ./anselme.can:60
error(("a %s line doesn't want children but was given some; at line %s in %s"):format(parent["type"], lineno, origin)) -- ./anselme.can:61
end -- ./anselme.can:61
elseif level < indent then -- ./anselme.can:64
while level < indent do -- ./anselme.can:65
indent = indent - (1) -- ./anselme.can:66
if parent["type"] == "paragraph" then -- ./anselme.can:67
parentParagraph = parentParagraph["parent"] -- ./anselme.can:68
end -- ./anselme.can:68
parent = parent["parent"] -- ./anselme.can:70
end -- ./anselme.can:70
elseif level ~= indent then -- ./anselme.can:73
error(("invalid indentation; at line %s in %s"):format(lineno, origin)) -- ./anselme.can:74
end -- ./anselme.can:74
local parsed -- ./anselme.can:78
parsed = { -- ./anselme.can:78
["type"] = "unknown", -- ./anselme.can:79
["parent"] = parent, -- ./anselme.can:80
["children"] = nil, -- ./anselme.can:81
["parentParagraph"] = parentParagraph, -- ./anselme.can:82
["root"] = root, -- ./anselme.can:83
["variables"] = nil, -- ./anselme.can:84
["condition"] = nil, -- ./anselme.can:86
["tags"] = nil, -- ./anselme.can:88
["paragraph"] = nil, -- ./anselme.can:90
["parameters"] = nil, -- ./anselme.can:91
["return"] = nil, -- ./anselme.can:92
["value"] = nil, -- ./anselme.can:93
["text"] = nil, -- ./anselme.can:95
["address"] = nil, -- ./anselme.can:97
["operator"] = nil, -- ./anselme.can:99
["expression"] = nil, -- ./anselme.can:101
["continue"] = nil, -- ./anselme.can:103
["temporary"] = temporary, -- ./anselme.can:105
["line"] = lineno, -- ./anselme.can:106
["origin"] = origin -- ./anselme.can:107
} -- ./anselme.can:107
if not line:match("^%(") then -- ./anselme.can:111
if line:match("^%s*[^%~].*%~[^%~]+$") then -- ./anselme.can:113
local s, c, e -- ./anselme.can:114
s, c, e = line:match("^(%s*[^%~].*)%~([^%~%#%§]+)(.-)$") -- ./anselme.can:114
local exp, rem -- ./anselme.can:115
exp, rem = expression(parsed, c) -- ./anselme.can:115
if rem:match("[^%s]") then -- ./anselme.can:116
error(("invalid condition decorator expression near %q; at line %s in %s"):format(rem, lineno, origin)) -- ./anselme.can:117
else -- ./anselme.can:117
line = s .. e -- ./anselme.can:119
parsed["condition"] = exp -- ./anselme.can:120
end -- ./anselme.can:120
end -- ./anselme.can:120
if line:match("^%s*[^%#].*%#[^%#]+$") then -- ./anselme.can:124
local s, c, e -- ./anselme.can:125
s, c, e = line:match("^(%s*[^%#].*)%#([^%~%#%§]+)(.-)$") -- ./anselme.can:125
local exp, rem -- ./anselme.can:126
exp, rem = expression(parsed, c) -- ./anselme.can:126
if rem:match("[^%s]") then -- ./anselme.can:127
error(("invalid tag decorator expression near %q; at line %s in %s"):format(rem, lineno, origin)) -- ./anselme.can:128
else -- ./anselme.can:128
line = s .. e -- ./anselme.can:130
parsed["tags"] = exp -- ./anselme.can:131
end -- ./anselme.can:131
end -- ./anselme.can:131
if line:match("^%s*[^%§].*%§[^%§]+$") then -- ./anselme.can:135
local s, c, e -- ./anselme.can:136
s, c, e = line:match("^(%s*[^%§].*)%§%s*([^%~%#%§]+)(.-)$") -- ./anselme.can:136
line = s .. e -- ./anselme.can:137
parsed["paragraph"] = c -- ./anselme.can:138
end -- ./anselme.can:138
end -- ./anselme.can:138
if line:match("^%(") then -- ./anselme.can:143
skipChildren = true -- ./anselme.can:144
goto __CAN_continue -- ./anselme.can:145
elseif line:match("^§") then -- ./anselme.can:147
parsed["type"] = "paragraph" -- ./anselme.can:148
parsed["paragraph"] = line:match("^§%s*(.-)%s*$") -- ./anselme.can:149
parsed["children"] = {} -- ./anselme.can:150
elseif line:match("^>") then -- ./anselme.can:152
parsed["type"] = "choice" -- ./anselme.can:153
parsed["children"] = {} -- ./anselme.can:154
local lastLine -- ./anselme.can:155
lastLine = parsed["parent"]["children"][# parsed["parent"]["children"]] -- ./anselme.can:155
if not lastLineEmpty and lastLine and (lastLine["type"] == "choice" or lastLine["type"] == "elsechoice") then -- ./anselme.can:156
parsed["continue"] = true -- ./anselme.can:157
end -- ./anselme.can:157
parsed["text"] = line:match("^>%s*(.-)%s*$") -- ./anselme.can:159
elseif line:match("^:") then -- ./anselme.can:161
parsed["type"] = "definition" -- ./anselme.can:162
parsed["expression"], parsed["address"] = expression(parsed, line:match("^:%s*(.-)%s*$")) -- ./anselme.can:163
local var, rem -- ./anselme.can:164
var, rem = expression(parsed, parsed["address"]) -- ./anselme.can:164
if rem:match("[^%s]") or var["type"] ~= "variable" then -- ./anselme.can:165
error(("unreasonably invalid variable name (%s); at line %s in %s"):format(parsed["address"], lineno, origin)) -- ./anselme.can:166
else -- ./anselme.can:166
parsed["address"] = evalAddress(parsed, var["address"]) -- ./anselme.can:168
end -- ./anselme.can:168
defineVariable(parsed, parsed["address"], eval(parsed, parsed["expression"])) -- ./anselme.can:171
elseif line:match("^[%=%+%-%*%/%%%?%!%^%&%|]") then -- ./anselme.can:173
parsed["type"] = "assignement" -- ./anselme.can:174
parsed["operator"] = line:match("^([%=%+%-%*%/%%%?%!%^%&%|])") -- ./anselme.can:175
parsed["expression"], parsed["address"] = expression(parsed, line:match("^[%=%+%-%*%/%%%?%!%^%&%|]%s*(.-)%s*$")) -- ./anselme.can:176
local var, rem -- ./anselme.can:177
var, rem = expression(parsed, parsed["address"]) -- ./anselme.can:177
if rem:match("[^%s]") or var["type"] ~= "variable" then -- ./anselme.can:178
error(("unreasonably invalid variable name (%s); at line %s in %s"):format(parsed["address"], lineno, origin)) -- ./anselme.can:179
else -- ./anselme.can:179
parsed["address"] = var["address"] -- ./anselme.can:181
end -- ./anselme.can:181
elseif line:match("^%~") then -- ./anselme.can:184
parsed["type"] = "redirection" -- ./anselme.can:185
parsed["children"] = {} -- ./anselme.can:186
local lastLine -- ./anselme.can:187
lastLine = parsed["parent"]["children"][# parsed["parent"]["children"]] -- ./anselme.can:187
if not lastLineEmpty and lastLine and lastLine["type"] == "redirection" then -- ./anselme.can:188
parsed["continue"] = true -- ./anselme.can:189
end -- ./anselme.can:189
local cond -- ./anselme.can:191
cond = line:match("^%~%s*(.-)%s*$") -- ./anselme.can:191
if cond == "" then -- ./anselme.can:192
cond = "1" -- ./anselme.can:192
end -- ./anselme.can:192
local exp, rem -- ./anselme.can:193
exp, rem = expression(parsed, cond) -- ./anselme.can:193
if rem:match("[^%s]") then -- ./anselme.can:194
error(("invalid redirection expression near %q; at line %s in %s"):format(rem, lineno, origin)) -- ./anselme.can:195
else -- ./anselme.can:195
parsed["expression"] = exp -- ./anselme.can:197
end -- ./anselme.can:197
elseif line:match("^%@") then -- ./anselme.can:200
parsed["type"] = "return" -- ./anselme.can:201
local exp, rem -- ./anselme.can:202
exp, rem = expression(parsed, line:match("^%@%s*(.-)%s*$")) -- ./anselme.can:202
if rem:match("[^%s]") then -- ./anselme.can:203
error(("invalid return expression near %q; at line %s in %s"):format(rem, lineno, origin)) -- ./anselme.can:204
else -- ./anselme.can:204
parsed["expression"] = exp -- ./anselme.can:206
end -- ./anselme.can:206
elseif line:match("^%#") then -- ./anselme.can:209
parsed["type"] = "tag" -- ./anselme.can:210
parsed["children"] = {} -- ./anselme.can:211
local exp, rem -- ./anselme.can:212
exp, rem = expression(parsed, line:match("^%#%s*(.-)%s*$")) -- ./anselme.can:212
if rem:match("[^%s]") then -- ./anselme.can:213
error(("invalid tag expression near %q; at line %s in %s"):format(rem, lineno, origin)) -- ./anselme.can:214
else -- ./anselme.can:214
parsed["expression"] = exp -- ./anselme.can:216
end -- ./anselme.can:216
else -- ./anselme.can:216
parsed["type"] = "text" -- ./anselme.can:220
parsed["text"] = line:match("^%s*(.-)%s*$") -- ./anselme.can:221
end -- ./anselme.can:221
if parsed["paragraph"] then -- ./anselme.can:225
local name, parameters -- ./anselme.can:226
name, parameters = parsed["paragraph"]:match("^%s*([^%(]+)(.-)%s*$") -- ./anselme.can:226
if name:match("%s") or name:match("^%{") then -- ./anselme.can:228
local var, rem -- ./anselme.can:229
var, rem = expression(parsed, name) -- ./anselme.can:229
if rem:match("[^%s]") or var["type"] ~= "variable" then -- ./anselme.can:230
error(("unreasonably invalid paragraph name (%s); at line %s in %s"):format(parsed["address"], lineno, origin)) -- ./anselme.can:231
else -- ./anselme.can:231
parsed["address"] = evalAddress(parsed, var["address"]) -- ./anselme.can:233
end -- ./anselme.can:233
else -- ./anselme.can:233
parsed["address"] = { name } -- ./anselme.can:236
end -- ./anselme.can:236
local pvar -- ./anselme.can:239
pvar = defineVariable(parent, parsed["address"], parsed) -- ./anselme.can:239
parsed["parameters"] = {} -- ./anselme.can:241
parsed["variables"] = pvar -- ./anselme.can:242
if parameters:match("^%s*%(.-%)%s*$") then -- ./anselme.can:243
local content -- ./anselme.can:244
content = parameters:match("^%s*%((.-)%)%s*$") -- ./anselme.can:244
for par in content:gmatch("[^,]+") do -- ./anselme.can:245
local var -- ./anselme.can:246
var = par:match("^%s*(.-)%s*$") -- ./anselme.can:246
table["insert"](parsed["parameters"], var) -- ./anselme.can:247
defineVariable(parsed, { var }, eval("0")) -- ./anselme.can:248
end -- ./anselme.can:248
end -- ./anselme.can:248
parsed["value"] = parsed -- ./anselme.can:251
defineVariable(parsed, { "👁️" }, eval("0")) -- ./anselme.can:252
defineVariable(parsed, { "🗨️" }, eval("0")) -- ./anselme.can:253
parsed["return"] = { -- ./anselme.can:254
["type"] = "string", -- ./anselme.can:254
["value"] = "" -- ./anselme.can:254
} -- ./anselme.can:254
end -- ./anselme.can:254
parent = parsed["parent"] -- ./anselme.can:258
table["insert"](parent["children"], parsed) -- ./anselme.can:259
lastParsed = parsed -- ./anselme.can:261
lastLineEmpty = false -- ./anselme.can:262
end -- ./anselme.can:262
::__CAN_continue:: -- ./anselme.can:262
end -- ./anselme.can:262
end -- ./anselme.can:262
expression = function(context, str, operatingOn, minPriority) -- ./anselme.can:267
if minPriority == nil then minPriority = 0 end -- ./anselme.can:267
str = str:match("^%s*(.-)$") -- ./anselme.can:269
if not operatingOn then -- ./anselme.can:273
if str == "" then -- ./anselme.can:275
error(("unexpected empty expression; at line %s in %s"):format(context["line"], context["origin"])) -- ./anselme.can:276
elseif str:match("^\"") then -- ./anselme.can:278
local string, remaining -- ./anselme.can:279
string, remaining = str:match("^\"([^\"]*)\"(.*)$") -- ./anselme.can:279
return expression(context, remaining, { -- ./anselme.can:280
["type"] = "string", -- ./anselme.can:281
["value"] = string -- ./anselme.can:282
}, minPriority) -- ./anselme.can:283
elseif str:match("^%d*%.%d+") then -- ./anselme.can:285
local number, remaining -- ./anselme.can:286
number, remaining = str:match("^(%d*%.%d+)(.*)$") -- ./anselme.can:286
return expression(context, remaining, { -- ./anselme.can:287
["type"] = "number", -- ./anselme.can:288
["value"] = tonumber(number) -- ./anselme.can:289
}, minPriority) -- ./anselme.can:290
elseif str:match("^%d+") then -- ./anselme.can:292
local number, remaining -- ./anselme.can:293
number, remaining = str:match("^(%d+)(.*)$") -- ./anselme.can:293
return expression(context, remaining, { -- ./anselme.can:294
["type"] = "number", -- ./anselme.can:295
["value"] = tonumber(number) -- ./anselme.can:296
}, minPriority) -- ./anselme.can:297
elseif str:match("^[%?%!%-]") then -- ./anselme.can:299
local op, rem -- ./anselme.can:300
op, rem = str:match("^([%?%!%-])(.*)$") -- ./anselme.can:300
local exp, remaining, lowerPriorityOp -- ./anselme.can:303
exp, remaining, lowerPriorityOp = expression(context, rem, nil, unopPriority[op]) -- ./anselme.can:303
local unop -- ./anselme.can:304
unop = { -- ./anselme.can:304
["type"] = "u" .. op, -- ./anselme.can:305
["expression"] = exp -- ./anselme.can:306
} -- ./anselme.can:306
if lowerPriorityOp then -- ./anselme.can:308
return expression(context, remaining, unop, minPriority) -- ./anselme.can:309
else -- ./anselme.can:309
return unop, remaining -- ./anselme.can:311
end -- ./anselme.can:311
elseif str:match("^%(") then -- ./anselme.can:314
local content, remaining -- ./anselme.can:315
content, remaining = str:match("^(%b())(.*)$") -- ./anselme.can:315
local exp, premaining -- ./anselme.can:316
exp, premaining = expression(context, content:match("^%((.*)%)$"), nil) -- ./anselme.can:316
if premaining:match("[^%s]") then -- ./anselme.can:317
error(("something in parantheses can't be read as an expression; at line %s in %s"):format(context["line"], context["origin"])) -- ./anselme.can:318
end -- ./anselme.can:318
return expression(context, remaining, { -- ./anselme.can:320
["type"] = "parantheses", -- ./anselme.can:321
["expression"] = exp -- ./anselme.can:322
}, minPriority) -- ./anselme.can:323
elseif str:match("^" .. pvariable) then -- ./anselme.can:325
local var, remaining -- ./anselme.can:326
var, remaining = str:match("^(" .. pvariable .. ")(.*)$") -- ./anselme.can:326
local address -- ./anselme.can:328
address = { { -- ./anselme.can:328
["type"] = "string", -- ./anselme.can:328
["value"] = var -- ./anselme.can:328
} } -- ./anselme.can:328
while remaining:match("^%s%s-" .. pvariable) or remaining:match("^%s-%b{}") do -- ./anselme.can:329
if remaining:match("^%s-%{") then -- ./anselme.can:330
var, remaining = remaining:match("^%s-(%b{})(.*)$") -- ./anselme.can:331
var = var:gsub("^%{", ""):gsub("%}$", "") -- ./anselme.can:332
local exp, rem -- ./anselme.can:333
exp, rem = expression(context, var) -- ./anselme.can:333
if rem:match("[^%s]") then -- ./anselme.can:334
error(("something in parantheses can't be read as an expression; in variable address at line %s in %s"):format(context["line"], context["origin"])) -- ./anselme.can:335
else -- ./anselme.can:335
table["insert"](address, exp) -- ./anselme.can:337
end -- ./anselme.can:337
else -- ./anselme.can:337
var, remaining = remaining:match("^%s%s-(" .. pvariable .. ")(.*)$") -- ./anselme.can:340
table["insert"](address, { -- ./anselme.can:341
["type"] = "string", -- ./anselme.can:342
["value"] = var -- ./anselme.can:343
}) -- ./anselme.can:343
end -- ./anselme.can:343
end -- ./anselme.can:343
return expression(context, remaining, { -- ./anselme.can:347
["type"] = "variable", -- ./anselme.can:348
["address"] = address -- ./anselme.can:349
}, minPriority) -- ./anselme.can:350
end -- ./anselme.can:350
else -- ./anselme.can:350
if str:match("^<=") or str:match("^>=") or str:match("^!=") or str:match("^//") or str:match("^[%&%|%+%-%*%/%%%<%>%=%^%:%,]") then -- ./anselme.can:357
local op, rem -- ./anselme.can:358
if str:match("^<=") or str:match("^>=") or str:match("^!=") then -- ./anselme.can:359
op, rem = str:match("^([<>!]=)(.*)$") -- ./anselme.can:360
elseif str:match("^//") then -- ./anselme.can:361
op, rem = str:match("^(//)(.*)$") -- ./anselme.can:362
else -- ./anselme.can:362
op, rem = str:match("^([%&%|%+%-%*%/%%%<%>%=%^%:%,])(.*)$") -- ./anselme.can:364
end -- ./anselme.can:364
if binopPriority[op] >= minPriority then -- ./anselme.can:367
local rightVal, remaining, lowerPriorityOp -- ./anselme.can:368
rightVal, remaining, lowerPriorityOp = expression(context, rem, nil, binopPriority[op]) -- ./anselme.can:368
local binop -- ./anselme.can:369
binop = { -- ./anselme.can:369
["type"] = "b" .. op, -- ./anselme.can:370
["left"] = operatingOn, -- ./anselme.can:371
["right"] = rightVal -- ./anselme.can:372
} -- ./anselme.can:372
if lowerPriorityOp then -- ./anselme.can:374
return expression(context, remaining, binop, minPriority) -- ./anselme.can:375
else -- ./anselme.can:375
return binop, remaining -- ./anselme.can:377
end -- ./anselme.can:377
else -- ./anselme.can:377
return operatingOn, str, true -- ./anselme.can:381
end -- ./anselme.can:381
elseif str:match("^%(") then -- ./anselme.can:384
local content, remaining -- ./anselme.can:385
content, remaining = str:match("^(%b())(.*)$") -- ./anselme.can:385
content = content:match("^%((.*)%)$") -- ./anselme.can:386
local args = nil -- ./anselme.can:387
if content:match("[^%s]") then -- ./anselme.can:388
local exp, rem -- ./anselme.can:389
exp, rem = expression(context, content) -- ./anselme.can:389
if rem:match("[^%s]") then -- ./anselme.can:390
error(("invalid function parameter expression near %q; at line %s in %s"):format(rem, context["line"], context["origin"])) -- ./anselme.can:391
end -- ./anselme.can:391
args = exp -- ./anselme.can:393
end -- ./anselme.can:393
return expression(context, remaining, { -- ./anselme.can:395
["type"] = "call", -- ./anselme.can:396
["expression"] = operatingOn, -- ./anselme.can:397
["arguments"] = args -- ./anselme.can:398
}, minPriority) -- ./anselme.can:399
elseif str:match("^[%d%.\"]") and minPriority < math["huge"] then -- ./anselme.can:401
local exp, rem -- ./anselme.can:402
exp, rem = expression(context, str, nil, math["huge"]) -- ./anselme.can:402
assert(exp["type"] == "number" or exp["type"] == "string", ("expected string or number but got a %s; in function call at line %s in %s"):format(exp["type"], context["line"], context["origin"])) -- ./anselme.can:403
return expression(context, rem, { -- ./anselme.can:404
["type"] = "call", -- ./anselme.can:405
["expression"] = operatingOn, -- ./anselme.can:406
["arguments"] = exp -- ./anselme.can:407
}, minPriority) -- ./anselme.can:408
else -- ./anselme.can:408
return operatingOn, str -- ./anselme.can:410
end -- ./anselme.can:410
end -- ./anselme.can:410
error(("the expression parser just gave up; at line %s in %s"):format(context["line"], context["origin"])) -- ./anselme.can:415
end -- ./anselme.can:415
defineVariable = function(context, address, value) -- ./anselme.can:420
local pvar -- ./anselme.can:421
pvar = context["variables"] or context["parentParagraph"]["variables"] -- ./anselme.can:421
for _, part in ipairs(address) do -- ./anselme.can:422
if not pvar[part] then -- ./anselme.can:423
pvar[part] = {} -- ./anselme.can:424
end -- ./anselme.can:424
pvar = pvar[part] -- ./anselme.can:426
end -- ./anselme.can:426
if pvar[1] then -- ./anselme.can:428
error(("variable %q already defined; at line %s in %s"):format(table["concat"](address, " "), context["line"], context["origin"])) -- ./anselme.can:429
end -- ./anselme.can:429
pvar[1] = value -- ./anselme.can:431
return pvar -- ./anselme.can:432
end -- ./anselme.can:432
findVariable = function(context, address) -- ./anselme.can:438
local root -- ./anselme.can:439
root = context["root"] -- ./anselme.can:439
local pvar -- ./anselme.can:441
pvar = context["variables"] -- ./anselme.can:441
if not pvar then -- ./anselme.can:442
return nil -- ./anselme.can:443
end -- ./anselme.can:443
for _, part in ipairs(address) do -- ./anselme.can:446
while true do -- ./anselme.can:447
do -- ./anselme.can:447
if pvar[part] then -- ./anselme.can:448
pvar = pvar[part] -- ./anselme.can:449
break -- ./anselme.can:450
end -- ./anselme.can:450
if root["aliases"][part] then -- ./anselme.can:453
local alias -- ./anselme.can:454
alias = root["aliases"][part] -- ./anselme.can:454
if pvar[alias] then -- ./anselme.can:455
pvar = pvar[alias] -- ./anselme.can:456
break -- ./anselme.can:457
end -- ./anselme.can:457
end -- ./anselme.can:457
local pval -- ./anselme.can:461
pval = pvar[1] -- ./anselme.can:461
if pval and context ~= pval and pval["type"] == "paragraph" then -- ./anselme.can:462
local r -- ./anselme.can:463
r = runFunction(context, pval) -- ./anselme.can:463
if type(r["value"]) == "table" and r["value"]["variables"] then -- ./anselme.can:464
pvar = r["value"]["variables"] -- ./anselme.can:465
goto __CAN_continue -- ./anselme.can:466
end -- ./anselme.can:466
end -- ./anselme.can:466
return nil -- ./anselme.can:470
end -- ./anselme.can:470
::__CAN_continue:: -- ./anselme.can:470
end -- ./anselme.can:470
end -- ./anselme.can:470
if pvar[1] then -- ./anselme.can:474
return pvar[1], pvar -- ./anselme.can:475
end -- ./anselme.can:475
return nil -- ./anselme.can:478
end -- ./anselme.can:478
lookupVariable = function(context, address) -- ./anselme.can:485
local parentParagraph -- ./anselme.can:487
parentParagraph = context -- ./anselme.can:487
while parentParagraph do -- ./anselme.can:488
local v, par -- ./anselme.can:489
v, par = findVariable(parentParagraph, address) -- ./anselme.can:489
if v then -- ./anselme.can:490
return v, par -- ./anselme.can:491
end -- ./anselme.can:491
parentParagraph = parentParagraph["parentParagraph"] -- ./anselme.can:493
end -- ./anselme.can:493
local root -- ./anselme.can:496
root = context["root"] -- ./anselme.can:496
for j = # address, 1, - 1 do -- ./anselme.can:497
local searchingForAddress -- ./anselme.can:498
searchingForAddress = table["concat"](address, " ", 1, j) -- ./anselme.can:498
for i, pending in ipairs(root["pendingScripts"]) do -- ./anselme.can:499
if pending["address"] == searchingForAddress then -- ./anselme.can:500
local code -- ./anselme.can:501
code = ("§ %s\
"):format(pending["address"]) -- ./anselme.can:501
local f -- ./anselme.can:502
f = io["open"](pending["path"], "r") -- ./anselme.can:502
for l in f:lines("*l") do -- ./anselme.can:503
code = code .. (("\9%s\
"):format(l)) -- ./anselme.can:504
end -- ./anselme.can:504
f:close() -- ./anselme.can:506
parse(root, code, pending["path"]) -- ./anselme.can:507
table["remove"](root["pendingScripts"], i) -- ./anselme.can:508
return findVariable(root, address) -- ./anselme.can:509
end -- ./anselme.can:509
end -- ./anselme.can:509
end -- ./anselme.can:509
return nil -- ./anselme.can:514
end -- ./anselme.can:514
runFunction = function(context, fn, args) -- ./anselme.can:518
if args == nil then args = {} end -- ./anselme.can:518
if fn["type"] == "paragraph" then -- ./anselme.can:519
local p -- ./anselme.can:521
p = fn["value"] -- ./anselme.can:521
if # args ~= # p["parameters"] then -- ./anselme.can:522
error(("paragraph (%s; at line %s in %s) expected %s parameters but received %s; at line %s in %s"):format(table["concat"](p["address"], " "), p["line"], p["origin"], # p["parameters"], # args, context["line"], context["origin"])) -- ./anselme.can:523
end -- ./anselme.can:523
for i, arg in ipairs(args) do -- ./anselme.can:525
p["variables"][p["parameters"][i]][1] = arg -- ./anselme.can:526
end -- ./anselme.can:526
p["return"] = { -- ./anselme.can:529
["type"] = "string", -- ./anselme.can:529
["value"] = "" -- ./anselme.can:529
} -- ./anselme.can:529
runChildren(p) -- ./anselme.can:530
return p["return"] -- ./anselme.can:531
elseif fn["type"] == "luafunction" then -- ./anselme.can:532
local luaArgs -- ./anselme.can:533
luaArgs = {} -- ./anselme.can:533
for i, arg in ipairs(args) do -- ./anselme.can:534
table["insert"](luaArgs, arg["value"]) -- ./anselme.can:535
end -- ./anselme.can:535
local ret -- ./anselme.can:537
ret = fn["value"](unpack(luaArgs)) -- ./anselme.can:537
local val -- ./anselme.can:538
val = luaToAns(ret) -- ./anselme.can:538
if val then -- ./anselme.can:539
return val -- ./anselme.can:540
else -- ./anselme.can:540
error(("invalid return type (%s) for luafunction in expression; at line %s in %s"):format(ret, context["line"], context["origin"])) -- ./anselme.can:542
end -- ./anselme.can:542
else -- ./anselme.can:542
error(("tried to call a %s variable in an expression; at line %s in %s"):format(fn["type"], context["line"], context["origin"])) -- ./anselme.can:545
end -- ./anselme.can:545
end -- ./anselme.can:545
tryPotentialFunction = function(context, potentialParentVariables, name, arguments) -- ./anselme.can:552
local fn -- ./anselme.can:553
for _, p in ipairs(potentialParentVariables) do -- ./anselme.can:555
if type(p["value"]) == "table" and p["value"]["variables"] then -- ./anselme.can:556
local v -- ./anselme.can:557
v = findVariable(p["value"], { name }) -- ./anselme.can:557
if v then -- ./anselme.can:558
fn = v -- ./anselme.can:559
break -- ./anselme.can:560
end -- ./anselme.can:560
end -- ./anselme.can:560
end -- ./anselme.can:560
if fn then -- ./anselme.can:565
return runFunction(context, fn, arguments) -- ./anselme.can:566
end -- ./anselme.can:566
end -- ./anselme.can:566
eval = function(context, exp) -- ./anselme.can:573
local remain = "" -- ./anselme.can:574
if type(context) == "string" and exp == nil then -- ./anselme.can:575
context, exp = {}, context -- ./anselme.can:576
end -- ./anselme.can:576
if type(exp) == "string" then -- ./anselme.can:578
exp, remain = expression(context, exp) -- ./anselme.can:579
end -- ./anselme.can:579
if remain:match("[^%s]") then -- ./anselme.can:581
error(("unexpected text in expression near %q; at line %s in %s"):format(remain, context["line"], context["origin"])) -- ./anselme.can:582
end -- ./anselme.can:582
assert(exp["type"], ("undefined variable type; at line %s in %s"):format(context["line"], context["origin"])) -- ./anselme.can:585
if exp["type"] == "number" then -- ./anselme.can:587
return { -- ./anselme.can:588
["type"] = "number", -- ./anselme.can:589
["value"] = exp["value"] -- ./anselme.can:590
} -- ./anselme.can:590
elseif exp["type"] == "string" then -- ./anselme.can:592
return { -- ./anselme.can:593
["type"] = "string", -- ./anselme.can:594
["value"] = formatText(context, exp["value"]) -- ./anselme.can:595
} -- ./anselme.can:595
elseif exp["type"] == "parantheses" then -- ./anselme.can:597
return eval(context, exp["expression"]) -- ./anselme.can:598
elseif exp["type"] == "variable" then -- ./anselme.can:600
local addr -- ./anselme.can:601
addr = evalAddress(context, exp["address"]) -- ./anselme.can:601
local v -- ./anselme.can:602
v = lookupVariable(context, addr) -- ./anselme.can:602
if v then -- ./anselme.can:603
if type(v["value"]) == "table" and v["value"]["paragraph"] then -- ./anselme.can:604
return { -- ./anselme.can:605
["type"] = "paragraph", -- ./anselme.can:606
["value"] = v["value"] -- ./anselme.can:607
} -- ./anselme.can:607
else -- ./anselme.can:607
return { -- ./anselme.can:610
["type"] = v["type"], -- ./anselme.can:611
["value"] = v["value"] -- ./anselme.can:612
} -- ./anselme.can:612
end -- ./anselme.can:612
end -- ./anselme.can:612
error(("can't find the variable (%s); at line %s in %s"):format(table["concat"](addr, " "), context["line"], context["origin"])) -- ./anselme.can:616
elseif exp["type"]:match("^b[%+%-%*%/%%%^%>%<%=%!%:%,][%/%=]?$") then -- ./anselme.can:618
local op -- ./anselme.can:619
op = exp["type"]:match("^b(.*)$") -- ./anselme.can:619
local left, right -- ./anselme.can:620
left, right = eval(context, exp["left"]), eval(context, exp["right"]) -- ./anselme.can:620
local customBinop -- ./anselme.can:621
customBinop = tryPotentialFunction(context, { -- ./anselme.can:621
left, -- ./anselme.can:621
right -- ./anselme.can:621
}, ("_%s_"):format(op), { -- ./anselme.can:621
left, -- ./anselme.can:621
right -- ./anselme.can:621
}) -- ./anselme.can:621
if customBinop then -- ./anselme.can:622
return customBinop -- ./anselme.can:622
end -- ./anselme.can:622
if op == "+" then -- ./anselme.can:623
if (left["type"] == "string" and (right["type"] == "string" or right["type"] == "number")) or ((left["type"] == "number" or left["type"] == "string") and right["type"] == "string") then -- ./anselme.can:625
return { -- ./anselme.can:626
["type"] = "string", -- ./anselme.can:627
["value"] = tostring(left["value"]) .. tostring(right["value"]) -- ./anselme.can:628
} -- ./anselme.can:628
elseif left["type"] == "number" and right["type"] == "number" then -- ./anselme.can:630
return { -- ./anselme.can:631
["type"] = "number", -- ./anselme.can:632
["value"] = tonumber(left["value"]) + tonumber(right["value"]) -- ./anselme.can:633
} -- ./anselme.can:633
end -- ./anselme.can:633
elseif op == "-" then -- ./anselme.can:636
if left["type"] == "string" and right["type"] == "number" then -- ./anselme.can:637
return { -- ./anselme.can:638
["type"] = "string", -- ./anselme.can:639
["value"] = tostring(left["value"]):sub(1, utf8["offset"](left["value"], utf8["len"](left["value"]) - tonumber(right["value"]))) -- ./anselme.can:640
} -- ./anselme.can:640
elseif left["type"] == "number" and right["type"] == "string" then -- ./anselme.can:642
return { -- ./anselme.can:643
["type"] = "string", -- ./anselme.can:644
["value"] = tostring(right["value"]):sub(utf8["offset"](right["value"], tonumber(left["value"]) + 1)) -- ./anselme.can:645
} -- ./anselme.can:645
elseif left["type"] == "number" and right["type"] == "number" then -- ./anselme.can:647
return { -- ./anselme.can:648
["type"] = "number", -- ./anselme.can:649
["value"] = tonumber(left["value"]) - tonumber(right["value"]) -- ./anselme.can:650
} -- ./anselme.can:650
elseif left["type"] == "string" and right["type"] == "string" then -- ./anselme.can:652
return { -- ./anselme.can:653
["type"] = "string", -- ./anselme.can:654
["value"] = tostring(left["value"]):gsub(tostring(right["value"]), "") -- ./anselme.can:655
} -- ./anselme.can:655
end -- ./anselme.can:655
elseif op == "*" then -- ./anselme.can:658
if left["type"] == "string" and right["type"] == "number" then -- ./anselme.can:659
return { -- ./anselme.can:660
["type"] = "string", -- ./anselme.can:661
["value"] = tostring(left["value"]):rep(tonumber(right["value"])) -- ./anselme.can:662
} -- ./anselme.can:662
elseif left["type"] == "number" and right["type"] == "string" then -- ./anselme.can:664
return { -- ./anselme.can:665
["type"] = "string", -- ./anselme.can:666
["value"] = tostring(right["value"]):rep(tonumber(left["value"])) -- ./anselme.can:667
} -- ./anselme.can:667
elseif left["type"] == "number" and right["type"] == "number" then -- ./anselme.can:669
return { -- ./anselme.can:670
["type"] = "number", -- ./anselme.can:671
["value"] = tonumber(left["value"]) * tonumber(right["value"]) -- ./anselme.can:672
} -- ./anselme.can:672
end -- ./anselme.can:672
elseif op == "/" then -- ./anselme.can:675
if left["type"] == "string" and right["type"] == "number" then -- ./anselme.can:676
return { -- ./anselme.can:677
["type"] = "string", -- ./anselme.can:678
["value"] = tostring(left["value"]):sub(utf8["offset"](left["value"], utf8["len"](left["value"]) - tonumber(right["value"]) + 1)) -- ./anselme.can:679
} -- ./anselme.can:679
elseif left["type"] == "number" and right["type"] == "string" then -- ./anselme.can:681
return { -- ./anselme.can:682
["type"] = "string", -- ./anselme.can:683
["value"] = tostring(right["value"]):sub(1, utf8["offset"](right["value"], tonumber(left["value"]))) -- ./anselme.can:684
} -- ./anselme.can:684
elseif left["type"] == "number" and right["type"] == "number" then -- ./anselme.can:686
return { -- ./anselme.can:687
["type"] = "number", -- ./anselme.can:688
["value"] = tonumber(left["value"]) / tonumber(right["value"]) -- ./anselme.can:689
} -- ./anselme.can:689
end -- ./anselme.can:689
elseif op == "//" then -- ./anselme.can:692
if left["type"] == "number" and right["type"] == "number" then -- ./anselme.can:693
return { -- ./anselme.can:694
["type"] = "number", -- ./anselme.can:695
["value"] = tonumber(left["value"]) // tonumber(right["value"]) -- ./anselme.can:696
} -- ./anselme.can:696
end -- ./anselme.can:696
elseif op == "%" then -- ./anselme.can:699
if (left["type"] == "string" and right["type"] == "number") or (left["type"] == "number" and right["type"] == "string") then -- ./anselme.can:700
return { -- ./anselme.can:701
["type"] = "number", -- ./anselme.can:702
["value"] = tostring(left["value"]):find(tostring(right["value"])) or 0 -- ./anselme.can:703
} -- ./anselme.can:703
elseif left["type"] == "number" and right["type"] == "number" then -- ./anselme.can:705
return { -- ./anselme.can:706
["type"] = "number", -- ./anselme.can:707
["value"] = tonumber(left["value"]) % tonumber(right["value"]) -- ./anselme.can:708
} -- ./anselme.can:708
end -- ./anselme.can:708
elseif op == "^" then -- ./anselme.can:711
if left["type"] == "string" then -- ./anselme.can:712
local s -- ./anselme.can:713
s = tostring(left["value"]) -- ./anselme.can:713
if evalBool(context, exp["right"])["value"] == 0 then -- ./anselme.can:714
s = s:lower() -- ./anselme.can:715
else -- ./anselme.can:715
s = s:upper() -- ./anselme.can:717
end -- ./anselme.can:717
return { -- ./anselme.can:719
["type"] = "string", -- ./anselme.can:720
["value"] = s -- ./anselme.can:721
} -- ./anselme.can:721
elseif left["type"] == "number" and right["type"] == "number" then -- ./anselme.can:723
return { -- ./anselme.can:724
["type"] = "number", -- ./anselme.can:725
["value"] = tonumber(left["value"]) ^ tonumber(right["value"]) -- ./anselme.can:726
} -- ./anselme.can:726
end -- ./anselme.can:726
elseif op == ">" then -- ./anselme.can:729
if (left["type"] == "number" or left["type"] == "string") and (right["type"] == "number" or right["type"] == "string") then -- ./anselme.can:730
return { -- ./anselme.can:731
["type"] = "number", -- ./anselme.can:732
["value"] = (left["value"] > right["value"]) and 1 or 0 -- ./anselme.can:733
} -- ./anselme.can:733
end -- ./anselme.can:733
elseif op == "<" then -- ./anselme.can:736
if (left["type"] == "number" or left["type"] == "string") and (right["type"] == "number" or right["type"] == "string") then -- ./anselme.can:737
return { -- ./anselme.can:738
["type"] = "number", -- ./anselme.can:739
["value"] = (left["value"] < right["value"]) and 1 or 0 -- ./anselme.can:740
} -- ./anselme.can:740
end -- ./anselme.can:740
elseif op == ">=" then -- ./anselme.can:743
if (left["type"] == "number" or left["type"] == "string") and (right["type"] == "number" or right["type"] == "string") then -- ./anselme.can:744
return { -- ./anselme.can:745
["type"] = "number", -- ./anselme.can:746
["value"] = (left["value"] >= right["value"]) and 1 or 0 -- ./anselme.can:747
} -- ./anselme.can:747
end -- ./anselme.can:747
elseif op == "<=" then -- ./anselme.can:750
if (left["type"] == "number" or left["type"] == "string") and (right["type"] == "number" or right["type"] == "string") then -- ./anselme.can:751
return { -- ./anselme.can:752
["type"] = "number", -- ./anselme.can:753
["value"] = (left["value"] <= right["value"]) and 1 or 0 -- ./anselme.can:754
} -- ./anselme.can:754
end -- ./anselme.can:754
elseif op == "=" then -- ./anselme.can:757
return { -- ./anselme.can:758
["type"] = "number", -- ./anselme.can:759
["value"] = (left["value"] == right["value"]) and 1 or 0 -- ./anselme.can:760
} -- ./anselme.can:760
elseif op == "!=" then -- ./anselme.can:762
return { -- ./anselme.can:763
["type"] = "number", -- ./anselme.can:764
["value"] = (left["value"] ~= right["value"]) and 1 or 0 -- ./anselme.can:765
} -- ./anselme.can:765
elseif op == ":" then -- ./anselme.can:767
return { -- ./anselme.can:768
["type"] = "pair", -- ./anselme.can:769
["value"] = { -- ./anselme.can:770
["name"] = left, -- ./anselme.can:770
["value"] = right -- ./anselme.can:770
} -- ./anselme.can:770
} -- ./anselme.can:770
elseif op == "," then -- ./anselme.can:772
return { -- ./anselme.can:773
["type"] = "list", -- ./anselme.can:774
["value"] = { -- ./anselme.can:775
["head"] = left, -- ./anselme.can:775
["tail"] = right -- ./anselme.can:775
} -- ./anselme.can:775
} -- ./anselme.can:775
end -- ./anselme.can:775
error(("invalid value types for %s operator: %s %s %s; at line %s in %s"):format(op, left["type"], op, right["type"], context["line"], context["origin"])) -- ./anselme.can:778
elseif exp["type"]:match("^u[%-%?%!]$") then -- ./anselme.can:779
local op -- ./anselme.can:780
op = exp["type"]:match("^u(.*)$") -- ./anselme.can:780
local value -- ./anselme.can:781
value = eval(context, exp["expression"]) -- ./anselme.can:781
local customUnop -- ./anselme.can:782
customUnop = tryPotentialFunction(context, { value }, ("%s_"):format(op), { value }) -- ./anselme.can:782
if customUnop then -- ./anselme.can:783
return customUnop -- ./anselme.can:783
end -- ./anselme.can:783
if op == "-" then -- ./anselme.can:784
if value["type"] == "number" then -- ./anselme.can:785
return { -- ./anselme.can:786
["type"] = "number", -- ./anselme.can:787
["value"] = - tonumber(value["value"]) -- ./anselme.can:788
} -- ./anselme.can:788
elseif value["type"] == "string" then -- ./anselme.can:790
return { -- ./anselme.can:791
["type"] = "string", -- ./anselme.can:792
["value"] = value["value"]:reverse() -- ./anselme.can:793
} -- ./anselme.can:793
end -- ./anselme.can:793
elseif op == "?" then -- ./anselme.can:796
if value["type"] == "paragraph" then -- ./anselme.can:797
return evalBool(context, { -- ./anselme.can:798
["type"] = "call", -- ./anselme.can:798
["expression"] = exp["expression"] -- ./anselme.can:798
}) -- ./anselme.can:798
else -- ./anselme.can:798
return { -- ./anselme.can:800
["type"] = "number", -- ./anselme.can:801
["value"] = (value["value"] == 0) and 0 or 1 -- ./anselme.can:802
} -- ./anselme.can:802
end -- ./anselme.can:802
elseif op == "!" then -- ./anselme.can:805
return { -- ./anselme.can:806
["type"] = "number", -- ./anselme.can:807
["value"] = evalBool(context, exp["expression"])["value"] == 0 and 1 or 0 -- ./anselme.can:808
} -- ./anselme.can:808
end -- ./anselme.can:808
error(("invalid value types for %s operator: %s; at line %s in %s"):format(op, value["type"], context["line"], context["origin"])) -- ./anselme.can:811
elseif exp["type"] == "b&" then -- ./anselme.can:813
if evalBool(exp["left"])["value"] == 0 then -- ./anselme.can:814
return left -- ./anselme.can:815
else -- ./anselme.can:815
return evalBool(context, exp["right"]) -- ./anselme.can:817
end -- ./anselme.can:817
elseif exp["type"] == "b|" then -- ./anselme.can:819
local left -- ./anselme.can:820
left = evalBool(context, exp["left"]) -- ./anselme.can:820
if left["value"] == 0 then -- ./anselme.can:821
return evalBool(context, exp["right"]) -- ./anselme.can:822
else -- ./anselme.can:822
return left -- ./anselme.can:824
end -- ./anselme.can:824
elseif exp["type"] == "call" then -- ./anselme.can:827
local fn -- ./anselme.can:828
fn = eval(context, exp["expression"]) -- ./anselme.can:828
if exp["arguments"] then -- ./anselme.can:829
return runFunction(context, fn, evalList(context, exp["arguments"])) -- ./anselme.can:830
else -- ./anselme.can:830
return runFunction(context, fn) -- ./anselme.can:832
end -- ./anselme.can:832
else -- ./anselme.can:832
error(("unkown expression (%s) to evaluate; at line %s in %s"):format(exp["type"], context["line"], context["origin"])) -- ./anselme.can:835
end -- ./anselme.can:835
end -- ./anselme.can:835
evalBool = function(context, expression) -- ./anselme.can:840
return eval(context, { -- ./anselme.can:841
["type"] = "u?", -- ./anselme.can:841
["expression"] = expression -- ./anselme.can:841
}) -- ./anselme.can:841
end -- ./anselme.can:841
evalNoParagraph = function(context, exp) -- ./anselme.can:845
local t -- ./anselme.can:846
t = eval(context, exp) -- ./anselme.can:846
while t["type"] == "paragraph" do -- ./anselme.can:847
t = runFunction(context, t) -- ./anselme.can:848
end -- ./anselme.can:848
return t -- ./anselme.can:850
end -- ./anselme.can:850
evalList = function(context, exp) -- ./anselme.can:854
local l -- ./anselme.can:855
l = {} -- ./anselme.can:855
local e -- ./anselme.can:856
e = eval(context, exp) -- ./anselme.can:856
while e["type"] == "list" do -- ./anselme.can:857
table["insert"](l, e["value"]["head"]) -- ./anselme.can:858
e = e["value"]["tail"] -- ./anselme.can:859
end -- ./anselme.can:859
table["insert"](l, e) -- ./anselme.can:861
return l -- ./anselme.can:862
end -- ./anselme.can:862
evalFlatListNoParagraph = function(context, exp) -- ./anselme.can:866
local l -- ./anselme.can:867
l = {} -- ./anselme.can:867
local extract -- ./anselme.can:868
extract = function(e) -- ./anselme.can:868
while e["type"] == "list" or e["type"] == "paragraph" do -- ./anselme.can:869
if e["type"] == "paragraph" then -- ./anselme.can:870
e = runFunction(context, e) -- ./anselme.can:871
else -- ./anselme.can:871
local hd -- ./anselme.can:873
hd = e["value"]["head"] -- ./anselme.can:873
if hd["type"] == "list" or hd["type"] == "paragraph" then -- ./anselme.can:874
extract(hd) -- ./anselme.can:875
else -- ./anselme.can:875
table["insert"](l, hd) -- ./anselme.can:877
end -- ./anselme.can:877
e = e["value"]["tail"] -- ./anselme.can:879
end -- ./anselme.can:879
end -- ./anselme.can:879
table["insert"](l, e) -- ./anselme.can:882
end -- ./anselme.can:882
extract(eval(context, exp)) -- ./anselme.can:884
return l -- ./anselme.can:885
end -- ./anselme.can:885
evalAddress = function(context, address) -- ./anselme.can:889
return (function() -- ./anselme.can:890
local self = {} -- ./anselme.can:890
for _, a in ipairs(address) do -- ./anselme.can:891
do -- ./anselme.can:892
local __CAN_a = table.pack(tostring(evalNoParagraph(context, a)["value"])) -- ./anselme.can:892
table.move(__CAN_a, 1, __CAN_a.n, #self+1, self) -- ./anselme.can:892
end -- ./anselme.can:892
end -- ./anselme.can:892
return self -- ./anselme.can:892
end)() -- ./anselme.can:892
end -- ./anselme.can:892
luaToAns = function(var) -- ./anselme.can:899
if var == nil or var == false then -- ./anselme.can:900
return eval("0") -- ./anselme.can:901
elseif var == true then -- ./anselme.can:902
return eval("1") -- ./anselme.can:903
elseif type(var) == "number" then -- ./anselme.can:904
return { -- ./anselme.can:905
["type"] = "number", -- ./anselme.can:906
["value"] = var -- ./anselme.can:907
} -- ./anselme.can:907
elseif type(var) == "string" then -- ./anselme.can:909
return { -- ./anselme.can:910
["type"] = "number", -- ./anselme.can:911
["value"] = var -- ./anselme.can:912
} -- ./anselme.can:912
elseif type(var) == "function" then -- ./anselme.can:914
return { -- ./anselme.can:915
["type"] = "luafunction", -- ./anselme.can:916
["value"] = var -- ./anselme.can:917
} -- ./anselme.can:917
elseif type(var) == "table" and var["type"] then -- ./anselme.can:919
return { -- ./anselme.can:920
["type"] = var["type"], -- ./anselme.can:921
["value"] = var["value"] -- ./anselme.can:922
} -- ./anselme.can:922
else -- ./anselme.can:922
error(("don't know how to convert a %s to a Anselme value"):format(type(var))) -- ./anselme.can:925
end -- ./anselme.can:925
end -- ./anselme.can:925
readable = function(var) -- ./anselme.can:930
if var["type"] == "pair" then -- ./anselme.can:931
return ("%s:%s"):format(readable(var["value"]["name"]), readable(var["value"]["value"])) -- ./anselme.can:932
elseif var["type"] == "list" then -- ./anselme.can:933
return ("%s,%s"):format(readable(var["value"]["head"]), readable(var["value"]["tail"])) -- ./anselme.can:934
else -- ./anselme.can:934
return tostring(var["value"]) -- ./anselme.can:936
end -- ./anselme.can:936
end -- ./anselme.can:936
formatText = function(context, text, yield) -- ./anselme.can:941
local r -- ./anselme.can:942
r = text:gsub("%b{}", function(exp) -- ./anselme.can:942
return readable(evalNoParagraph(context, exp:match("^{(.*)}$"))) -- ./anselme.can:943
end) -- ./anselme.can:943
return r -- ./anselme.can:945
end -- ./anselme.can:945
sendEvent = function(root) -- ./anselme.can:950
local e -- ./anselme.can:951
e = root["event"] or root -- ./anselme.can:951
root["event"] = nil -- ./anselme.can:952
if e[1] == "choice" then -- ./anselme.can:953
local vm -- ./anselme.can:954
vm = coroutine["yield"]("choice", e[2]) -- ./anselme.can:954
if not vm["state"]["chosen"] then -- ./anselme.can:955
error("no choice has been made by the engine, I don't know what to doooooo") -- ./anselme.can:956
end -- ./anselme.can:956
local c -- ./anselme.can:958
c = assert(e[3][vm["state"]["chosen"]], ("invalid choice %s, expected something in [1,%s]"):format(vm["state"]["chosen"], # e[2])) -- ./anselme.can:958
vm["state"]["chosen"] = nil -- ./anselme.can:959
runChildren(c) -- ./anselme.can:960
else -- ./anselme.can:960
coroutine["yield"](e[1], e[2]) -- ./anselme.can:962
end -- ./anselme.can:962
end -- ./anselme.can:962
pushTags = function(context, tags) -- ./anselme.can:967
local root -- ./anselme.can:968
root = context["root"] -- ./anselme.can:968
local oldTags -- ./anselme.can:969
oldTags = root["tags"] -- ./anselme.can:969
local newTags -- ./anselme.can:970
newTags = (function() -- ./anselme.can:970
local self = {} -- ./anselme.can:970
for k, v in pairs(root["tags"]) do -- ./anselme.can:970
self[k] = v -- ./anselme.can:970
end -- ./anselme.can:970
return self -- ./anselme.can:970
end)() -- ./anselme.can:970
local l -- ./anselme.can:971
l = evalFlatListNoParagraph(context, tags) -- ./anselme.can:971
for _, t in ipairs(l) do -- ./anselme.can:972
if t["type"] == "pair" then -- ./anselme.can:973
local name, value -- ./anselme.can:974
name, value = t["value"]["name"], t["value"]["value"] -- ./anselme.can:974
while name["type"] == "paragraph" do -- ./anselme.can:975
name = runFunction(context, name) -- ./anselme.can:976
end -- ./anselme.can:976
while value["type"] == "paragraph" do -- ./anselme.can:978
value = runFunction(context, value) -- ./anselme.can:979
end -- ./anselme.can:979
newTags[name["value"]] = value["value"] -- ./anselme.can:981
else -- ./anselme.can:981
table["insert"](newTags, t["value"]) -- ./anselme.can:983
end -- ./anselme.can:983
end -- ./anselme.can:983
root["tags"] = newTags -- ./anselme.can:986
return oldTags -- ./anselme.can:987
end -- ./anselme.can:987
runChildren = function(line) -- ./anselme.can:991
run(line["children"]) -- ./anselme.can:992
if line["paragraph"] then -- ./anselme.can:993
line["variables"]["🗨️"][1]["value"] = line["variables"]["🗨️"][1]["value"] + (1) -- ./anselme.can:993
end -- ./anselme.can:993
end -- ./anselme.can:993
run = function(lines, i) -- ./anselme.can:999
if i == nil then i = 1 end -- ./anselme.can:999
if # lines == 0 then -- ./anselme.can:1001
return i -- ./anselme.can:1002
end -- ./anselme.can:1002
local root -- ./anselme.can:1005
root = lines[1]["root"] -- ./anselme.can:1005
while i <= # lines do -- ./anselme.can:1007
do -- ./anselme.can:1007
local line -- ./anselme.can:1008
line = lines[i] -- ./anselme.can:1008
i = i + (1) -- ./anselme.can:1009
if # root["interrupts"] > 0 then -- ./anselme.can:1011
for _, e in ipairs(root["interrupts"]) do -- ./anselme.can:1012
sendEvent(e) -- ./anselme.can:1013
end -- ./anselme.can:1013
root["interrupts"] = {} -- ./anselme.can:1015
end -- ./anselme.can:1015
if line["condition"] then -- ./anselme.can:1018
if evalBool(line, line["condition"])["value"] == 0 then -- ./anselme.can:1019
goto __CAN_continue -- ./anselme.can:1020
end -- ./anselme.can:1020
end -- ./anselme.can:1020
local oldTags -- ./anselme.can:1024
if line["tags"] then -- ./anselme.can:1025
oldTags = pushTags(line, line["tags"]) -- ./anselme.can:1026
end -- ./anselme.can:1026
if line["type"] == "paragraph" or line["type"] == "definition" then -- ./anselme.can:1029
 -- ./anselme.can:1031
elseif line["type"] == "choice" then -- ./anselme.can:1031
if root["event"] and root["event"][1] ~= "choice" then -- ./anselme.can:1033
sendEvent(root) -- ./anselme.can:1034
end -- ./anselme.can:1034
if not root["event"] then -- ./anselme.can:1037
root["event"] = { -- ./anselme.can:1038
"choice", -- ./anselme.can:1038
{}, -- ./anselme.can:1038
{} -- ./anselme.can:1038
} -- ./anselme.can:1038
end -- ./anselme.can:1038
local isBuffered = false -- ./anselme.can:1041
local t -- ./anselme.can:1042
t = formatText(line, line["text"]) -- ./anselme.can:1042
if t:match("\\$") then -- ./anselme.can:1043
t = t:gsub("\\$", "") -- ./anselme.can:1044
isBuffered = true -- ./anselme.can:1045
end -- ./anselme.can:1045
table["insert"](root["event"][2], { -- ./anselme.can:1047
["text"] = t, -- ./anselme.can:1047
["tags"] = root["tags"] -- ./anselme.can:1047
}) -- ./anselme.can:1047
table["insert"](root["event"][3], line) -- ./anselme.can:1048
if i <= # lines and lines[i]["type"] == "choice" and lines[i]["continue"] then -- ./anselme.can:1050
isBuffered = true -- ./anselme.can:1051
end -- ./anselme.can:1051
if not isBuffered then -- ./anselme.can:1054
sendEvent(root) -- ./anselme.can:1055
end -- ./anselme.can:1055
elseif line["type"] == "assignement" then -- ./anselme.can:1057
local addr -- ./anselme.can:1059
addr = evalAddress(line, line["address"]) -- ./anselme.can:1059
local v, pvar -- ./anselme.can:1061
v, pvar = lookupVariable(line, addr) -- ./anselme.can:1061
if not v then -- ./anselme.can:1062
error(("can't find the variable (%s); at line %s in %s"):format(table["concat"](addr, " "), line["line"], line["origin"])) -- ./anselme.can:1063
end -- ./anselme.can:1063
local exp -- ./anselme.can:1066
exp = eval(line, line["expression"]) -- ./anselme.can:1066
local cv -- ./anselme.can:1068
cv = tryPotentialFunction(line, { v }, line["operator"], { -- ./anselme.can:1068
v, -- ./anselme.can:1068
exp -- ./anselme.can:1068
}) -- ./anselme.can:1068
if cv then -- ./anselme.can:1069
 -- ./anselme.can:1071
else -- ./anselme.can:1071
if line["operator"] ~= "=" then -- ./anselme.can:1073
exp = eval(line, { -- ./anselme.can:1074
["type"] = "b" .. line["operator"], -- ./anselme.can:1075
["left"] = { -- ./anselme.can:1076
["type"] = "variable", -- ./anselme.can:1077
["address"] = line["address"] -- ./anselme.can:1078
}, -- ./anselme.can:1078
["right"] = exp -- ./anselme.can:1080
}) -- ./anselme.can:1080
end -- ./anselme.can:1080
if pvar[1] then -- ./anselme.can:1084
if v["type"] ~= exp["type"] then -- ./anselme.can:1085
error(("tried to replace the variable %q of type %s with a %s; at line %s in %s"):format(table["concat"](addr, " "), v["type"], exp["type"], line["line"], line["origin"])) -- ./anselme.can:1086
else -- ./anselme.can:1086
pvar[1] = { -- ./anselme.can:1088
["type"] = exp["type"], -- ./anselme.can:1089
["value"] = exp["value"] -- ./anselme.can:1090
} -- ./anselme.can:1090
end -- ./anselme.can:1090
else -- ./anselme.can:1090
error(("found the variable (%s) to assign, but it's inaccessible; at line %s in %s"):format(table["concat"](addr, " "), line["line"], line["origin"])) -- ./anselme.can:1094
end -- ./anselme.can:1094
end -- ./anselme.can:1094
elseif line["type"] == "redirection" then -- ./anselme.can:1097
if evalBool(line, line["expression"])["value"] ~= 0 then -- ./anselme.can:1098
runChildren(line) -- ./anselme.can:1099
while i <= # lines and lines[i]["type"] == "redirection" and lines[i]["continue"] do -- ./anselme.can:1100
i = i + (1) -- ./anselme.can:1101
end -- ./anselme.can:1101
end -- ./anselme.can:1101
elseif line["type"] == "return" then -- ./anselme.can:1104
line["parentParagraph"]["return"] = eval(line, line["expression"]) -- ./anselme.can:1105
elseif line["type"] == "tag" then -- ./anselme.can:1106
local oldTags -- ./anselme.can:1107
oldTags = pushTags(line, line["expression"]) -- ./anselme.can:1107
run(line["children"]) -- ./anselme.can:1108
root["tags"] = oldTags -- ./anselme.can:1109
elseif line["type"] == "text" then -- ./anselme.can:1110
if root["event"] and root["event"][1] ~= "text" then -- ./anselme.can:1112
sendEvent(root) -- ./anselme.can:1113
end -- ./anselme.can:1113
if not root["event"] then -- ./anselme.can:1116
root["event"] = { -- ./anselme.can:1117
"text", -- ./anselme.can:1117
{} -- ./anselme.can:1117
} -- ./anselme.can:1117
end -- ./anselme.can:1117
local t -- ./anselme.can:1119
t = formatText(line, line["text"]) -- ./anselme.can:1119
if t:match("\\$") then -- ./anselme.can:1120
table["insert"](root["event"][2], { -- ./anselme.can:1121
["text"] = t:gsub("\\$", ""), -- ./anselme.can:1121
["tags"] = root["tags"] -- ./anselme.can:1121
}) -- ./anselme.can:1121
else -- ./anselme.can:1121
table["insert"](root["event"][2], { -- ./anselme.can:1123
["text"] = t, -- ./anselme.can:1123
["tags"] = root["tags"] -- ./anselme.can:1123
}) -- ./anselme.can:1123
sendEvent(root) -- ./anselme.can:1124
end -- ./anselme.can:1124
else -- ./anselme.can:1124
error(("element unknown to the runtime (%s); at line %s in %s"):format(line["type"], line["line"], line["origin"])) -- ./anselme.can:1127
end -- ./anselme.can:1127
if line["paragraph"] then -- ./anselme.can:1130
line["variables"]["👁️"][1]["value"] = line["variables"]["👁️"][1]["value"] + (1) -- ./anselme.can:1131
end -- ./anselme.can:1131
if line["tags"] then -- ./anselme.can:1134
root["tags"] = oldTags -- ./anselme.can:1135
end -- ./anselme.can:1135
if line["temporary"] then -- ./anselme.can:1138
i = i - (1) -- ./anselme.can:1139
table["remove"](lines, i) -- ./anselme.can:1140
end -- ./anselme.can:1140
end -- ./anselme.can:1140
::__CAN_continue:: -- ./anselme.can:1140
end -- ./anselme.can:1140
return i -- ./anselme.can:1143
end -- ./anselme.can:1143
step = function(self) -- ./anselme.can:1147
self["_coroutine"] = coroutine["running"]() -- ./anselme.can:1148
while true do -- ./anselme.can:1149
self["state"]["lastLine"] = run(self["state"]["children"], self["state"]["lastLine"]) -- ./anselme.can:1150
if self["state"]["event"] then -- ./anselme.can:1151
sendEvent(self["state"]) -- ./anselme.can:1151
end -- ./anselme.can:1151
coroutine["yield"]("end") -- ./anselme.can:1152
end -- ./anselme.can:1152
end -- ./anselme.can:1152
local isFile -- ./anselme.can:1157
isFile = function(path) -- ./anselme.can:1157
if love then -- ./anselme.can:1158
return love["filesystem"]["getInfo"](path, "file") -- ./anselme.can:1159
else -- ./anselme.can:1159
return require("lfs")["attributes"](path, "mode") == "file" -- ./anselme.can:1161
end -- ./anselme.can:1161
end -- ./anselme.can:1161
local isDir -- ./anselme.can:1164
isDir = function(path) -- ./anselme.can:1164
if love then -- ./anselme.can:1165
return love["filesystem"]["getInfo"](path, "directory") -- ./anselme.can:1166
else -- ./anselme.can:1166
return require("lfs")["attributes"](path, "mode") == "directory" -- ./anselme.can:1168
end -- ./anselme.can:1168
end -- ./anselme.can:1168
local listDir -- ./anselme.can:1171
listDir = function(path) -- ./anselme.can:1171
if love then -- ./anselme.can:1172
return love["filesystem"]["getDirectoryItems"](path) -- ./anselme.can:1173
else -- ./anselme.can:1173
return (function() -- ./anselme.can:1175
local self = {} -- ./anselme.can:1175
for item in require("lfs")["dir"](path) do -- ./anselme.can:1175
self[#self+1] = item -- ./anselme.can:1175
end -- ./anselme.can:1175
return self -- ./anselme.can:1175
end)() -- ./anselme.can:1175
end -- ./anselme.can:1175
end -- ./anselme.can:1175
insertAnselmsScriptsFromDirectory = function(list, dir, addressPrefix) -- ./anselme.can:1179
if addressPrefix == nil then addressPrefix = "" end -- ./anselme.can:1179
for _, f in ipairs(listDir(dir)) do -- ./anselme.can:1180
local path -- ./anselme.can:1181
path = ("%s/%s"):format(dir, f) -- ./anselme.can:1181
if isFile(path) then -- ./anselme.can:1182
if path:match("%.ans$") then -- ./anselme.can:1183
table["insert"](list, { -- ./anselme.can:1184
["path"] = path, -- ./anselme.can:1184
["address"] = ("%s%s"):format(addressPrefix, f:match("^(.*)%.ans$")) -- ./anselme.can:1184
}) -- ./anselme.can:1184
end -- ./anselme.can:1184
elseif isDir(path) then -- ./anselme.can:1186
insertAnselmsScriptsFromDirectory(list, path, ("%s "):format(f)) -- ./anselme.can:1187
end -- ./anselme.can:1187
end -- ./anselme.can:1187
end -- ./anselme.can:1187
local vm_mt -- ./anselme.can:1195
vm_mt = { -- ./anselme.can:1195
["state"] = nil, -- ./anselme.can:1198
["register"] = function(self, name, var) -- ./anselme.can:1217
if type(name) == "table" then -- ./anselme.can:1218
for k, v in pairs(name) do -- ./anselme.can:1219
self:register(k, v) -- ./anselme.can:1220
end -- ./anselme.can:1220
return self -- ./anselme.can:1222
elseif type(var) == "table" and not var["type"] then -- ./anselme.can:1223
for k, v in pairs(var) do -- ./anselme.can:1224
self:register(("%s %s"):format(name, k), v) -- ./anselme.can:1225
end -- ./anselme.can:1225
if var[1] then -- ./anselme.can:1227
self:register(name, var[1]) -- ./anselme.can:1228
end -- ./anselme.can:1228
return self -- ./anselme.can:1230
else -- ./anselme.can:1230
defineVariable(self["state"], (function() -- ./anselme.can:1232
local self = {} -- ./anselme.can:1232
for p in name:gmatch("[^%s]+") do -- ./anselme.can:1232
self[#self+1] = p -- ./anselme.can:1232
end -- ./anselme.can:1232
return self -- ./anselme.can:1232
end)(), luaToAns(var)) -- ./anselme.can:1232
return self -- ./anselme.can:1233
end -- ./anselme.can:1233
end, -- ./anselme.can:1233
["loadfile"] = function(self, path) -- ./anselme.can:1238
local f -- ./anselme.can:1239
f = io["open"](path, "r") -- ./anselme.can:1239
if not f then -- ./anselme.can:1240
error(("can't open file %q"):format(path)) -- ./anselme.can:1240
end -- ./anselme.can:1240
parse(self["state"], f:read("*a"), path) -- ./anselme.can:1241
f:close() -- ./anselme.can:1242
return self -- ./anselme.can:1243
end, -- ./anselme.can:1243
["loaddirectory"] = function(self, path) -- ./anselme.can:1248
insertAnselmsScriptsFromDirectory(self["state"]["pendingScripts"], path) -- ./anselme.can:1249
return self -- ./anselme.can:1250
end, -- ./anselme.can:1250
["load"] = function(self, code, origin) -- ./anselme.can:1253
parse(self["state"], code, origin) -- ./anselme.can:1254
return self -- ./anselme.can:1255
end, -- ./anselme.can:1255
["execfile"] = function(self, path) -- ./anselme.can:1262
local f -- ./anselme.can:1263
f = io["open"](path, "r") -- ./anselme.can:1263
if not f then -- ./anselme.can:1264
error("can't open file \"" .. tostring(path) .. "\"") -- ./anselme.can:1264
end -- ./anselme.can:1264
parse(self["state"], f:read("*a"), path, true) -- ./anselme.can:1265
f:close() -- ./anselme.can:1266
return self -- ./anselme.can:1267
end, -- ./anselme.can:1267
["exec"] = function(self, code, origin) -- ./anselme.can:1273
parse(self["state"], code, origin, true) -- ./anselme.can:1274
return self -- ./anselme.can:1275
end, -- ./anselme.can:1275
["eval"] = function(self, exp) -- ./anselme.can:1280
local v -- ./anselme.can:1281
v = eval(self["state"], exp) -- ./anselme.can:1281
return v["value"] -- ./anselme.can:1282
end, -- ./anselme.can:1282
["choose"] = function(self, i) -- ./anselme.can:1287
self["state"]["chosen"] = assert(i, "expected a choice but none was given") -- ./anselme.can:1288
return self -- ./anselme.can:1289
end, -- ./anselme.can:1289
["interrupt"] = function(self, name, data) -- ./anselme.can:1295
if coroutine["running"]() == self["_coroutine"] then -- ./anselme.can:1296
coroutine["yield"](name, data) -- ./anselme.can:1297
else -- ./anselme.can:1297
table["insert"](self["state"]["interrupts"], { -- ./anselme.can:1299
name, -- ./anselme.can:1299
data -- ./anselme.can:1299
}) -- ./anselme.can:1299
end -- ./anselme.can:1299
end, -- ./anselme.can:1299
["step"] = nil, -- ./anselme.can:1309
["_coroutine"] = nil -- ./anselme.can:1312
} -- ./anselme.can:1312
vm_mt["__index"] = vm_mt -- ./anselme.can:1314
local newVM -- ./anselme.can:1317
newVM = function(state) -- ./anselme.can:1317
local root -- ./anselme.can:1319
root = state or { -- ./anselme.can:1319
["type"] = "root", -- ./anselme.can:1321
["children"] = {}, -- ./anselme.can:1322
["variables"] = {}, -- ./anselme.can:1323
["line"] = 0, -- ./anselme.can:1324
["origin"] = "root", -- ./anselme.can:1325
["chosen"] = nil, -- ./anselme.can:1327
["event"] = nil, -- ./anselme.can:1328
["interrupts"] = {}, -- ./anselme.can:1329
["lastLine"] = 1, -- ./anselme.can:1330
["tags"] = {}, -- ./anselme.can:1331
["aliases"] = {}, -- ./anselme.can:1332
["pendingScripts"] = {} -- ./anselme.can:1333
} -- ./anselme.can:1333
root["root"] = root -- ./anselme.can:1335
local vm -- ./anselme.can:1338
vm = setmetatable({ -- ./anselme.can:1338
["state"] = root, -- ./anselme.can:1339
["step"] = coroutine["wrap"](step) -- ./anselme.can:1340
}, vm_mt) -- ./anselme.can:1341
vm:register("↩️", function(dest, source) -- ./anselme.can:1344
root["aliases"][source] = dest -- ./anselme.can:1345
end) -- ./anselme.can:1345
return vm -- ./anselme.can:1348
end -- ./anselme.can:1348
return setmetatable({ -- ./anselme.can:1351
["VERSION"] = VERSION, -- ./anselme.can:1353
["new"] = newVM -- ./anselme.can:1355
}, { ["__call"] = function() -- ./anselme.can:1358
return newVM() -- ./anselme.can:1359
end }) -- ./anselme.can:1359
