local json -- ./gltf.can:1
json = require((...):match("^(.*)loader%.gltf$") .. "lib.json") -- ./gltf.can:1
local dunpack -- ./gltf.can:2
dunpack = string["unpack"] or love["data"]["unpack"] -- ./gltf.can:2
local v3 -- ./gltf.can:3
v3 = require((...):match("^(.*)loader%.gltf$") .. "math.v3") -- ./gltf.can:3
local m4 -- ./gltf.can:4
m4 = require((...):match("^(.*)loader%.gltf$") .. "math.m4") -- ./gltf.can:4
local qt -- ./gltf.can:5
qt = require((...):match("^(.*)loader%.gltf$") .. "math.qt") -- ./gltf.can:5
local bb3 -- ./gltf.can:6
bb3 = require((...):match("^(.*)loader%.gltf$") .. "math.bb3") -- ./gltf.can:6
local bs3 -- ./gltf.can:7
bs3 = require((...):match("^(.*)loader%.gltf$") .. "math.bs3") -- ./gltf.can:7
local lg -- ./gltf.can:8
lg = love["graphics"] -- ./gltf.can:8
local drawNode -- ./gltf.can:10
drawNode = function(self, shader) -- ./gltf.can:10
if self["mesh"] then -- ./gltf.can:11
shader:send("model_transform", self["finalMatrix"]) -- ./gltf.can:12
for _, primitive in ipairs(self["mesh"]["primitives"]) do -- ./gltf.can:13
if shader:hasUniform("baseColorFactor") then -- ./gltf.can:14
shader:send("baseColorFactor", primitive["material"]["pbrMetallicRoughness"]["baseColorFactor"]) -- ./gltf.can:15
end -- ./gltf.can:15
lg["draw"](primitive["mesh"]) -- ./gltf.can:17
end -- ./gltf.can:17
end -- ./gltf.can:17
for _, child in ipairs(self["children"]) do -- ./gltf.can:20
drawNode(child, shader) -- ./gltf.can:21
end -- ./gltf.can:21
end -- ./gltf.can:21
local setTransform -- ./gltf.can:25
setTransform = function(self, tr) -- ./gltf.can:25
self["finalMatrix"] = tr * self["matrix"] -- ./gltf.can:26
for _, child in ipairs(self["children"]) do -- ./gltf.can:27
setTransform(child, tr) -- ./gltf.can:28
end -- ./gltf.can:28
end -- ./gltf.can:28
local boundingBox -- ./gltf.can:32
boundingBox = function(self, bb) -- ./gltf.can:32
if self["mesh"] then -- ./gltf.can:33
for _, primitive in ipairs(self["mesh"]["primitives"]) do -- ./gltf.can:34
if not bb then -- ./gltf.can:35
bb = bb3["fromMesh"](primitive["mesh"]) -- ./gltf.can:36
else -- ./gltf.can:36
bb:include(bb3["fromMesh"](primitive["mesh"])) -- ./gltf.can:38
end -- ./gltf.can:38
end -- ./gltf.can:38
end -- ./gltf.can:38
for _, child in ipairs(self["children"]) do -- ./gltf.can:42
bb = boundingBox(child, bb) -- ./gltf.can:43
end -- ./gltf.can:43
return bb -- ./gltf.can:45
end -- ./gltf.can:45
local boundingSphere -- ./gltf.can:48
boundingSphere = function(self, bs) -- ./gltf.can:48
if self["mesh"] then -- ./gltf.can:49
for _, primitive in ipairs(self["mesh"]["primitives"]) do -- ./gltf.can:50
if not bs then -- ./gltf.can:51
bs = bs3["fromMesh"](primitive["mesh"]) -- ./gltf.can:52
else -- ./gltf.can:52
bs:include(bs3["fromMesh"](primitive["mesh"])) -- ./gltf.can:54
end -- ./gltf.can:54
end -- ./gltf.can:54
end -- ./gltf.can:54
for _, child in ipairs(self["children"]) do -- ./gltf.can:58
bs = boundingBox(child, bs) -- ./gltf.can:59
end -- ./gltf.can:59
return bs -- ./gltf.can:61
end -- ./gltf.can:61
local gltf_mt -- ./gltf.can:64
gltf_mt = { -- ./gltf.can:64
["data"] = nil, -- ./gltf.can:65
["draw"] = function(self, shader) -- ./gltf.can:66
for _, node in ipairs(self["data"]["scene"]["nodes"]) do -- ./gltf.can:67
drawNode(node, shader) -- ./gltf.can:68
end -- ./gltf.can:68
end, -- ./gltf.can:68
["setTransform"] = function(self, tr) -- ./gltf.can:71
for _, node in ipairs(self["data"]["scene"]["nodes"]) do -- ./gltf.can:72
setTransform(node, tr) -- ./gltf.can:73
end -- ./gltf.can:73
end, -- ./gltf.can:73
["boundingBox"] = function(self) -- ./gltf.can:76
local bb -- ./gltf.can:77
for _, node in ipairs(self["data"]["scene"]["nodes"]) do -- ./gltf.can:78
bb = boundingBox(node, bb) -- ./gltf.can:79
end -- ./gltf.can:79
return bb -- ./gltf.can:81
end, -- ./gltf.can:81
["boundingSphere"] = function(self) -- ./gltf.can:83
local bs -- ./gltf.can:84
for _, node in ipairs(self["data"]["scene"]["nodes"]) do -- ./gltf.can:85
bs = boundingSphere(node, bs) -- ./gltf.can:86
end -- ./gltf.can:86
return bs -- ./gltf.can:88
end -- ./gltf.can:88
} -- ./gltf.can:88
gltf_mt["__index"] = gltf_mt -- ./gltf.can:91
local attributeName -- ./gltf.can:93
attributeName = { -- ./gltf.can:93
["POSITION"] = "VertexPosition", -- ./gltf.can:94
["NORMAL"] = "VertexNormal", -- ./gltf.can:95
["TANGENT"] = "VertexTangent", -- ./gltf.can:96
["TEXCOORD_0"] = "VertexTexCoord", -- ./gltf.can:97
["TEXCOORD_1"] = "VertexTexCoord1", -- ./gltf.can:98
["COLOR_0"] = "VertexColor", -- ./gltf.can:99
["JOINTS_0"] = "VertexJoints", -- ./gltf.can:100
["WEIGHTS_0"] = "VertexWeights" -- ./gltf.can:101
} -- ./gltf.can:101
local componentType -- ./gltf.can:104
componentType = { -- ./gltf.can:104
[5120] = "byte", -- ./gltf.can:105
[5121] = "unsigned byte", -- ./gltf.can:106
[5122] = "short", -- ./gltf.can:107
[5123] = "unsigned short", -- ./gltf.can:108
[5125] = "int", -- ./gltf.can:109
[5126] = "float" -- ./gltf.can:110
} -- ./gltf.can:110
local mode -- ./gltf.can:113
mode = { -- ./gltf.can:113
[0] = "points", -- ./gltf.can:114
[1] = "lines", -- ./gltf.can:115
[2] = "line_loop", -- ./gltf.can:116
[3] = "line_strip", -- ./gltf.can:117
[4] = "triangles", -- ./gltf.can:118
[5] = "strip", -- ./gltf.can:119
[6] = "fan" -- ./gltf.can:120
} -- ./gltf.can:120
local gltf -- ./gltf.can:139
gltf = function(file) -- ./gltf.can:139
local f -- ./gltf.can:140
f = assert(io["open"](file, "r")) -- ./gltf.can:140
local t -- ./gltf.can:141
t = json["decode"](f:read("*a")) -- ./gltf.can:141
f:close() -- ./gltf.can:142
if t["asset"]["minVersion"] then -- ./gltf.can:145
local maj, min -- ./gltf.can:146
maj, min = t["asset"]["minVersion"]:match("^(%d+)%.(%d+)$") -- ./gltf.can:146
assert(maj == "2" and min == "0", ("asset require at least glTF version %s.%s but we only support 2.0"):format(maj, min)) -- ./gltf.can:147
else -- ./gltf.can:147
local maj, min -- ./gltf.can:149
maj, min = t["asset"]["version"]:match("^(%d+)%.(%d+)$") -- ./gltf.can:149
assert(maj == "2", ("asset require glTF version %s.%s but we only support 2.x"):format(maj, min)) -- ./gltf.can:150
end -- ./gltf.can:150
t["nodes"] = t["nodes"] or ({}) -- ./gltf.can:154
t["scenes"] = t["scenes"] or ({}) -- ./gltf.can:155
t["cameras"] = t["cameras"] or ({}) -- ./gltf.can:156
t["meshes"] = t["meshes"] or ({}) -- ./gltf.can:157
t["buffers"] = t["buffers"] or ({}) -- ./gltf.can:158
t["bufferViews"] = t["bufferViews"] or ({}) -- ./gltf.can:159
t["accessors"] = t["accessors"] or ({}) -- ./gltf.can:160
t["materials"] = t["materials"] or ({}) -- ./gltf.can:161
t["textures"] = t["textures"] or ({}) -- ./gltf.can:162
t["images"] = t["images"] or ({}) -- ./gltf.can:163
t["samplers"] = t["samplers"] or ({}) -- ./gltf.can:164
t["skins"] = t["skins"] or ({}) -- ./gltf.can:165
t["animations"] = t["animations"] or ({}) -- ./gltf.can:166
for _, scene in ipairs(t["scenes"]) do -- ./gltf.can:169
if scene["name"] then -- ./gltf.can:170
t["scenes"][scene["name"]] = scene -- ./gltf.can:170
end -- ./gltf.can:170
for i, node in ipairs(scene["nodes"]) do -- ./gltf.can:171
scene["nodes"][i] = t["nodes"][node + 1] -- ./gltf.can:172
if scene["nodes"][i]["name"] then -- ./gltf.can:173
scene["nodes"][scene["nodes"][i]["name"]] = scene["nodes"][i] -- ./gltf.can:173
end -- ./gltf.can:173
end -- ./gltf.can:173
end -- ./gltf.can:173
if t["scene"] then -- ./gltf.can:178
t["scene"] = t["scenes"][t["scene"] + 1] -- ./gltf.can:179
end -- ./gltf.can:179
for _, node in ipairs(t["nodes"]) do -- ./gltf.can:183
if node["name"] then -- ./gltf.can:184
t["nodes"][node["name"]] = node -- ./gltf.can:184
end -- ./gltf.can:184
node["children"] = node["children"] or ({}) -- ./gltf.can:185
for i, child in ipairs(node["children"]) do -- ./gltf.can:186
node["children"][i] = t["nodes"][child + 1] -- ./gltf.can:187
end -- ./gltf.can:187
if node["matrix"] then -- ./gltf.can:189
node["matrix"] = m4["fromColumnMajor"](node["matrix"]) -- ./gltf.can:190
else -- ./gltf.can:190
node["translation"] = node["translation"] or ({ -- ./gltf.can:192
0, -- ./gltf.can:192
0, -- ./gltf.can:192
0 -- ./gltf.can:192
}) -- ./gltf.can:192
node["rotation"] = node["rotation"] or ({ -- ./gltf.can:193
0, -- ./gltf.can:193
0, -- ./gltf.can:193
0, -- ./gltf.can:193
1 -- ./gltf.can:193
}) -- ./gltf.can:193
node["scale"] = node["scale"] or ({ -- ./gltf.can:194
1, -- ./gltf.can:194
1, -- ./gltf.can:194
1 -- ./gltf.can:194
}) -- ./gltf.can:194
node["translation"] = v3(node["translation"]) -- ./gltf.can:196
node["rotation"] = qt(node["rotation"]) -- ./gltf.can:197
node["scale"] = v3(node["scale"]) -- ./gltf.can:198
node["matrix"] = m4["translate"](node["translation"]) * node["rotation"]:toM4() * m4["scale"](node["scale"]) -- ./gltf.can:200
end -- ./gltf.can:200
if node["mesh"] then -- ./gltf.can:202
node["mesh"] = t["meshes"][node["mesh"] + 1] -- ./gltf.can:203
end -- ./gltf.can:203
if node["camera"] then -- ./gltf.can:205
node["camera"] = t["cameras"][node["camera"] + 1] -- ./gltf.can:206
end -- ./gltf.can:206
end -- ./gltf.can:206
for i, buffer in ipairs(t["buffers"]) do -- ./gltf.can:211
if i == 1 and not buffer["uri"] then -- ./gltf.can:212
error("no support for glb-stored buffer") -- ./gltf.can:213
end -- ./gltf.can:213
if buffer["uri"]:match("data:") then -- ./gltf.can:215
local data = buffer["uri"]:match("^data:.-,(.*)$") -- ./gltf.can:216
if buffer["uri"]:match("^data:.-;base64,") then -- ./gltf.can:217
buffer["data"] = love["data"]["decode"]("string", "base64", data):sub(1, buffer["byteLength"] + 1) -- ./gltf.can:218
else -- ./gltf.can:218
buffer["data"] = data:gsub("%%(%x%x)", function(hex) -- ./gltf.can:220
return love["data"]["decode"]("string", "hex", hex) -- ./gltf.can:221
end):sub(1, buffer["byteLength"] + 1) -- ./gltf.can:222
end -- ./gltf.can:222
else -- ./gltf.can:222
local f -- ./gltf.can:225
f = assert(io["open"](buffer["uri"], "r"), ("can't find ressource %s"):format(buffer["uri"])) -- ./gltf.can:225
local s -- ./gltf.can:226
s = f:read("*a") -- ./gltf.can:226
f:close() -- ./gltf.can:227
buffer["data"] = s:sub(1, buffer["byteLength"] + 1) -- ./gltf.can:228
end -- ./gltf.can:228
end -- ./gltf.can:228
for _, view in ipairs(t["bufferViews"]) do -- ./gltf.can:233
view["buffer"] = t["buffers"][view["buffer"] + 1] -- ./gltf.can:234
view["byteOffset"] = view["byteOffset"] or (0) -- ./gltf.can:235
end -- ./gltf.can:235
for _, accessor in ipairs(t["accessors"]) do -- ./gltf.can:240
accessor["bufferView"] = t["bufferViews"][accessor["bufferView"] + 1] -- ./gltf.can:241
accessor["byteOffset"] = accessor["byteOffset"] or (0) -- ./gltf.can:242
local view -- ./gltf.can:244
view = accessor["bufferView"] -- ./gltf.can:244
local data -- ./gltf.can:245
data = view["buffer"]["data"] -- ./gltf.can:245
local fmt, size -- ./gltf.can:247
accessor["componentType"] = componentType[accessor["componentType"]] -- ./gltf.can:248
if accessor["componentType"] == "byte" then -- ./gltf.can:249
fmt, size = "b", 1 -- ./gltf.can:250
elseif accessor["componentType"] == "unsigned byte" then -- ./gltf.can:251
fmt, size = "B", 1 -- ./gltf.can:252
elseif accessor["componentType"] == "short" then -- ./gltf.can:253
fmt, size = "h", 2 -- ./gltf.can:254
elseif accessor["componentType"] == "unsigned short" then -- ./gltf.can:255
fmt, size = "H", 2 -- ./gltf.can:256
elseif accessor["componentType"] == "unsigned int" then -- ./gltf.can:257
fmt, size = "I4", 4 -- ./gltf.can:258
elseif accessor["componentType"] == "float" then -- ./gltf.can:259
fmt, size = "f", 4 -- ./gltf.can:260
end -- ./gltf.can:260
if accessor["type"] == "SCALAR" then -- ./gltf.can:263
accessor["components"], fmt = 1, fmt -- ./gltf.can:264
elseif accessor["type"] == "VEC2" then -- ./gltf.can:265
accessor["components"], fmt = 2, fmt:rep(2) -- ./gltf.can:266
elseif accessor["type"] == "VEC3" then -- ./gltf.can:267
accessor["components"], fmt = 3, fmt:rep(3) -- ./gltf.can:268
elseif accessor["type"] == "VEC4" then -- ./gltf.can:269
accessor["components"], fmt = 4, fmt:rep(4) -- ./gltf.can:270
elseif accessor["type"] == "MAT2" then -- ./gltf.can:271
accessor["components"] = 4 -- ./gltf.can:272
fmt = (fmt:rep(2) .. ("x"):rep(4 - (size * 2) % 4)):rep(2) -- ./gltf.can:273
elseif accessor["type"] == "MAT3" then -- ./gltf.can:274
accessor["components"] = 9 -- ./gltf.can:275
fmt = (fmt:rep(3) .. ("x"):rep(4 - (size * 3) % 4)):rep(3) -- ./gltf.can:276
elseif accessor["type"] == "MAT4" then -- ./gltf.can:277
accessor["components"] = 16 -- ./gltf.can:278
fmt = (fmt:rep(4) .. ("x"):rep(4 - (size * 4) % 4)):rep(4) -- ./gltf.can:279
end -- ./gltf.can:279
fmt = ("<") .. fmt -- ./gltf.can:282
accessor["data"] = {} -- ./gltf.can:284
local i -- ./gltf.can:285
i = view["byteOffset"] + 1 + accessor["byteOffset"] -- ./gltf.can:285
local stop -- ./gltf.can:286
stop = view["byteOffset"] + 1 + view["byteLength"] -- ./gltf.can:286
local count = 0 -- ./gltf.can:287
while i < stop and count < accessor["count"] do -- ./gltf.can:288
local d = { dunpack(fmt, data, i) } -- ./gltf.can:289
d[# d] = nil -- ./gltf.can:290
if accessor["components"] > 1 then -- ./gltf.can:291
table["insert"](accessor["data"], d) -- ./gltf.can:292
else -- ./gltf.can:292
table["insert"](accessor["data"], d[1]) -- ./gltf.can:294
end -- ./gltf.can:294
count = count + (1) -- ./gltf.can:296
i = i + (view["byteStride"] or (size * accessor["components"])) -- ./gltf.can:297
end -- ./gltf.can:297
end -- ./gltf.can:297
t["materials"][0] = { -- ./gltf.can:304
["pbrMetallicRoughness"] = { -- ./gltf.can:305
["baseColorFactor"] = { -- ./gltf.can:306
1, -- ./gltf.can:306
1, -- ./gltf.can:306
1, -- ./gltf.can:306
1 -- ./gltf.can:306
}, -- ./gltf.can:306
["metallicFactor"] = 1, -- ./gltf.can:307
["roughnessFactor"] = 1 -- ./gltf.can:308
}, -- ./gltf.can:308
["emissiveFactor"] = { -- ./gltf.can:310
0, -- ./gltf.can:310
0, -- ./gltf.can:310
0 -- ./gltf.can:310
}, -- ./gltf.can:310
["alphaMode"] = "OPAQUE", -- ./gltf.can:311
["alphaCutoff"] = .5, -- ./gltf.can:312
["doubleSided"] = false -- ./gltf.can:313
} -- ./gltf.can:313
for _, material in ipairs(t["materials"]) do -- ./gltf.can:315
material["pbrMetallicRoughness"] = material["pbrMetallicRoughness"] or ({}) -- ./gltf.can:316
material["pbrMetallicRoughness"]["baseColorFactor"] = material["pbrMetallicRoughness"]["baseColorFactor"] or ({ -- ./gltf.can:317
1, -- ./gltf.can:317
1, -- ./gltf.can:317
1, -- ./gltf.can:317
1 -- ./gltf.can:317
}) -- ./gltf.can:317
material["pbrMetallicRoughness"]["metallicFactor"] = material["pbrMetallicRoughness"]["metallicFactor"] or (1) -- ./gltf.can:318
material["pbrMetallicRoughness"]["roughnessFactor"] = material["pbrMetallicRoughness"]["roughnessFactor"] or (1) -- ./gltf.can:319
material["emissiveFactor"] = material["emissiveFactor"] or ({ -- ./gltf.can:320
0, -- ./gltf.can:320
0, -- ./gltf.can:320
0 -- ./gltf.can:320
}) -- ./gltf.can:320
material["alphaMode"] = material["alphaMode"] or ("OPAQUE") -- ./gltf.can:321
material["alphaCutoff"] = material["alphaCutoff"] or (.5) -- ./gltf.can:322
material["doubleSided"] = material["doubleSided"] or (false) -- ./gltf.can:323
end -- ./gltf.can:323
for _, mesh in ipairs(t["meshes"]) do -- ./gltf.can:327
for _, primitive in ipairs(mesh["primitives"]) do -- ./gltf.can:328
local vertexformat -- ./gltf.can:329
vertexformat = {} -- ./gltf.can:329
local vertices -- ./gltf.can:330
vertices = {} -- ./gltf.can:330
for n, v in pairs(primitive["attributes"]) do -- ./gltf.can:331
local accessor -- ./gltf.can:332
accessor = t["accessors"][v + 1] -- ./gltf.can:332
primitive["attributes"][n] = accessor -- ./gltf.can:333
table["insert"](vertexformat, { -- ./gltf.can:334
attributeName[n] or n, -- ./gltf.can:334
accessor["componentType"], -- ./gltf.can:334
accessor["components"] -- ./gltf.can:334
}) -- ./gltf.can:334
for i, f in ipairs(accessor["data"]) do -- ./gltf.can:335
local vertex -- ./gltf.can:336
vertex = vertices[i] -- ./gltf.can:336
if not vertex then -- ./gltf.can:337
table["insert"](vertices, i, {}) -- ./gltf.can:338
vertex = vertices[i] -- ./gltf.can:339
end -- ./gltf.can:339
for _, c in ipairs(f) do -- ./gltf.can:341
table["insert"](vertex, c) -- ./gltf.can:342
end -- ./gltf.can:342
end -- ./gltf.can:342
end -- ./gltf.can:342
if primitive["mode"] then -- ./gltf.can:347
primitive["mode"] = mode[primitive["mode"]] -- ./gltf.can:348
else -- ./gltf.can:348
primitive["mode"] = "triangles" -- ./gltf.can:350
end -- ./gltf.can:350
primitive["mesh"] = lg["newMesh"](vertexformat, vertices, primitive["mode"]) -- ./gltf.can:353
if primitive["indices"] then -- ./gltf.can:354
primitive["indices"] = (function() -- ./gltf.can:355
local self = {} -- ./gltf.can:355
for _, i in ipairs(t["accessors"][primitive["indices"] + 1]["data"]) do -- ./gltf.can:355
self[#self+1] = i + 1 -- ./gltf.can:355
end -- ./gltf.can:355
return self -- ./gltf.can:355
end)() -- ./gltf.can:355
primitive["mesh"]:setVertexMap(primitive["indices"]) -- ./gltf.can:356
end -- ./gltf.can:356
primitive["material"] = t["materials"][(primitive["material"] or - 1) + 1] -- ./gltf.can:359
end -- ./gltf.can:359
end -- ./gltf.can:359
for _, camera in ipairs(t["cameras"]) do -- ./gltf.can:370
if camera["name"] then -- ./gltf.can:371
t["cameras"][camera["name"]] = camera -- ./gltf.can:371
end -- ./gltf.can:371
if camera["type"] == "perspective" then -- ./gltf.can:372
camera["perspective"]["aspectRatio"] = camera["perspective"]["aspectRatio"] or (16 / 9) -- ./gltf.can:373
camera["matrix"] = m4["perspective"](camera["perspective"]["yfov"], camera["perspective"]["aspectRatio"], camera["perspective"]["znear"], camera["perspective"]["zfar"]) -- ./gltf.can:374
elseif camera["type"] == "orthographic" then -- ./gltf.can:375
camera["matrix"] = m4["orthographic"](camera["orthographic"]["xmag"], camera["orthographic"]["ymag"], camera["orthographic"]["znear"], camera["orthographic"]["zfar"]) -- ./gltf.can:376
end -- ./gltf.can:376
end -- ./gltf.can:376
return setmetatable({ ["data"] = t }, gltf_mt) -- ./gltf.can:388
end -- ./gltf.can:388
return gltf -- ./gltf.can:391
