local input -- ./debug.can:2
input = require("input") -- ./debug.can:2
local event -- ./debug.can:3
event = uqt["signal"]["event"] -- ./debug.can:3
local scenes -- ./debug.can:5
scenes = uqt["util"]["map"](love["filesystem"]["getDirectoryItems"]("source/scene"), function(v) -- ./debug.can:5
if v:match("can$") then -- ./debug.can:6
return v:match("^(.*)%..-$") -- ./debug.can:7
end -- ./debug.can:7
end) -- ./debug.can:7
table["insert"](scenes, 1, "go to") -- ./debug.can:10
local log -- ./debug.can:12
log = require("log"):new("system.debug") -- ./debug.can:12
local debug -- ./debug.can:14
debug = { -- ./debug.can:14
["name"] = "debug", -- ./debug.can:15
["ui"] = nil, -- ./debug.can:17
["added"] = false, -- ./debug.can:19
["onInstance"] = function(self) -- ./debug.can:21
if not self["added"] then -- ./debug.can:23
require("log")["level"] = - 1 -- ./debug.can:24
log("Debug mode activated") -- ./debug.can:25
love["keyboard"]["setKeyRepeat"](true) -- ./debug.can:27
love["mouse"]["setVisible"](true) -- ./debug.can:28
event:bind("keypressed", function(key, scancode, isrepeat) -- ./debug.can:31
self["ui"]:keypressed(key, scancode, isrepeat) -- ./debug.can:31
end) -- ./debug.can:31
event:bind("keyreleased", function(key, scancode) -- ./debug.can:32
self["ui"]:keyreleased(key, scancode) -- ./debug.can:32
end) -- ./debug.can:32
event:bind("mousepressed", function(x, y, button, istouch, presses) -- ./debug.can:33
self["ui"]:mousepressed(x, y, button, istouch, presses) -- ./debug.can:33
end) -- ./debug.can:33
event:bind("mousereleased", function(x, y, button, istouch, presses) -- ./debug.can:34
self["ui"]:mousereleased(x, y, button, istouch, presses) -- ./debug.can:34
end) -- ./debug.can:34
event:bind("mousemoved", function(x, y, dx, dy, istouch) -- ./debug.can:35
self["ui"]:mousemoved(x, y, dx, dy, istouch) -- ./debug.can:35
end) -- ./debug.can:35
event:bind("textinput", function(text) -- ./debug.can:36
self["ui"]:textinput(text) -- ./debug.can:36
end) -- ./debug.can:36
event:bind("wheelmoved", function(x, y) -- ./debug.can:37
self["ui"]:wheelmoved(x, y) -- ./debug.can:37
end) -- ./debug.can:37
end -- ./debug.can:37
self["added"] = true -- ./debug.can:39
local nuklear = require("nuklear") -- ./debug.can:42
self["ui"] = nuklear["newUI"]() -- ./debug.can:43
self["ui"]:styleLoadColors({ -- ./debug.can:44
["text"] = "#afafaf", -- ./debug.can:45
["window"] = "#2d2d2d", -- ./debug.can:46
["header"] = "#282828", -- ./debug.can:47
["border"] = "#414141", -- ./debug.can:48
["button"] = "#323232", -- ./debug.can:49
["button hover"] = "#282828", -- ./debug.can:50
["button active"] = "#232323", -- ./debug.can:51
["toggle"] = "#646464", -- ./debug.can:52
["toggle hover"] = "#787878", -- ./debug.can:53
["toggle cursor"] = "#000000", -- ./debug.can:54
["select"] = "#2d2d2d", -- ./debug.can:55
["select active"] = "#232323", -- ./debug.can:56
["slider"] = "#262626", -- ./debug.can:57
["slider cursor"] = "#646464", -- ./debug.can:58
["slider cursor hover"] = "#787878", -- ./debug.can:59
["slider cursor active"] = "#969696", -- ./debug.can:60
["property"] = "#262626", -- ./debug.can:61
["edit"] = "#262626", -- ./debug.can:62
["edit cursor"] = "#afafaf", -- ./debug.can:63
["combo"] = "#2d2d2d", -- ./debug.can:64
["chart"] = "#787878", -- ./debug.can:65
["chart color"] = "#2d2d2d", -- ./debug.can:66
["chart color highlight"] = "#ff0000", -- ./debug.can:67
["scrollbar"] = "#282828", -- ./debug.can:68
["scrollbar cursor"] = "#646464", -- ./debug.can:69
["scrollbar cursor hover"] = "#787878", -- ./debug.can:70
["scrollbar cursor active"] = "#969696", -- ./debug.can:71
["tab header"] = "#282828" -- ./debug.can:72
}) -- ./debug.can:72
end, -- ./debug.can:72
["onUpdate"] = function(self) -- ./debug.can:76
if input["showDebugUi"]:pressed() then -- ./debug.can:77
self["visible"] = not self["visible"] -- ./debug.can:78
end -- ./debug.can:78
end, -- ./debug.can:78
["onDraw"] = function(self) -- ./debug.can:82
self["ui"]:frameBegin() -- ./debug.can:83
self["ui"]:window("Debugax-3000", 975, 5, 300, 300, "minimizable", "title", "movable", "scalable", "scrollbar", "scroll auto hide", function() -- ./debug.can:84
self["ui"]:layoutRow("dynamic", 25, { -- ./debug.can:85
.7, -- ./debug.can:85
.3 -- ./debug.can:85
}) -- ./debug.can:85
self["ui"]:label(("%s entities, %s FPS"):format(self["world"]["entityCount"], love["timer"]["getFPS"]())) -- ./debug.can:86
local i -- ./debug.can:87
i = self["ui"]:combobox(1, scenes) -- ./debug.can:87
if i > 1 then -- ./debug.can:88
uqt["scene"]["switch"](scenes[i]) -- ./debug.can:89
end -- ./debug.can:89
for _, s in pairs(self["s"]) do -- ./debug.can:91
if s["debug"] then -- ./debug.can:92
s:debug(self["ui"]) -- ./debug.can:93
end -- ./debug.can:93
end -- ./debug.can:93
end) -- ./debug.can:93
for _, s in pairs(self["s"]) do -- ./debug.can:97
if s["debugUi"] then -- ./debug.can:98
s:debugUi(self["ui"]) -- ./debug.can:99
end -- ./debug.can:99
end -- ./debug.can:99
self["ui"]:frameEnd() -- ./debug.can:102
self["ui"]:draw() -- ./debug.can:103
end -- ./debug.can:103
} -- ./debug.can:103
return debug -- ./debug.can:107
