local inspect -- ./log.can:4
inspect = require("inspect") -- ./log.can:4
local timer -- ./log.can:5
timer = uqt["timer"] -- ./log.can:5
local levels -- ./log.can:7
levels = { -- ./log.can:7
[- 2] = "trace", -- ./log.can:8
[- 1] = "debug", -- ./log.can:9
[- 0] = "info", -- ./log.can:10
[1] = "warn", -- ./log.can:11
[2] = "error" -- ./log.can:12
} -- ./log.can:12
local logDisplayTime = 10000 -- ./log.can:15
local logFont -- ./log.can:16
logFont = lg["newFont"]() -- ./log.can:16
local concat -- ./log.can:18
concat = function(...) -- ./log.can:18
local s = "" -- ./log.can:19
for _, v in ipairs({ ... }) do -- ./log.can:20
if type(v) == "string" then -- ./log.can:21
s = s .. (v .. "\9") -- ./log.can:22
else -- ./log.can:22
s = s .. (inspect(v) .. "\
") -- ./log.can:24
end -- ./log.can:24
end -- ./log.can:24
return s:sub(1, - 2) -- ./log.can:27
end -- ./log.can:27
local log -- ./log.can:30
log = { -- ./log.can:30
["name"] = "log", -- ./log.can:31
["level"] = 0, -- ./log.can:33
["logs"] = {}, -- ./log.can:34
["onDraw"] = function(self) -- ./log.can:36
local i, y = 1, lg["getHeight"]() - logFont:getHeight() + 5 -- ./log.can:37
while i <= # self["logs"] do -- ./log.can:38
local t -- ./log.can:39
t = self["logs"][i] -- ./log.can:39
local a -- ./log.can:40
a = 1 - (love["timer"]["getTime"]() * 1000 - t["created"]) / logDisplayTime -- ./log.can:40
if a < 0 or y < 0 then -- ./log.can:41
table["remove"](self["logs"], i) -- ./log.can:42
else -- ./log.can:42
y = y - (t["text"]:getHeight()) -- ./log.can:44
lg["setColor"](1, 1, 1, a) -- ./log.can:45
lg["draw"](t["text"], 0, y) -- ./log.can:46
i = i + (1) -- ./log.can:47
end -- ./log.can:47
end -- ./log.can:47
end, -- ./log.can:47
["loggers"] = { -- ./log.can:53
function(level, levelName, context, message) -- ./log.can:54
if log["level"] <= level then -- ./log.can:55
print(("%s[%s] %s: %s"):format((" "):rep(5 - # levelName), levelName, context, message)) -- ./log.can:56
end -- ./log.can:56
end, -- ./log.can:56
function(level, levelName, context, message) -- ./log.can:59
if log["level"] <= level then -- ./log.can:60
local text -- ./log.can:61
text = lg["newText"](logFont) -- ./log.can:61
text:addf({ -- ./log.can:62
{ -- ./log.can:62
1, -- ./log.can:62
1 - level / 3, -- ./log.can:62
1 - level / 3, -- ./log.can:62
1 -- ./log.can:62
}, -- ./log.can:62
("[%s] "):format(levelName), -- ./log.can:62
{ -- ./log.can:62
1, -- ./log.can:62
1, -- ./log.can:62
1, -- ./log.can:62
1 -- ./log.can:62
}, -- ./log.can:62
("%s: %s"):format(context, message) -- ./log.can:62
}, lg["getWidth"]() - 10, "left", 5, 5) -- ./log.can:62
table["insert"](log["logs"], 1, { -- ./log.can:63
["created"] = love["timer"]["getTime"]() * 1000, -- ./log.can:63
["text"] = text -- ./log.can:63
}) -- ./log.can:63
end -- ./log.can:63
end -- ./log.can:63
}, -- ./log.can:63
["new"] = function(self, context) -- ./log.can:67
return setmetatable((function() -- ./log.can:68
local self = {} -- ./log.can:68
for level, name in pairs(levels) do -- ./log.can:69
self[name] = function(...) -- ./log.can:70
for _, l in ipairs(log["loggers"]) do -- ./log.can:70
l(level, name, context, concat(...)) -- ./log.can:70
end -- ./log.can:70
end -- ./log.can:70
end -- ./log.can:70
return self -- ./log.can:70
end)(), { ["__call"] = function(self, ...) -- ./log.can:73
self["info"](...) -- ./log.can:74
end }) -- ./log.can:74
end, -- ./log.can:74
["debug"] = function(self, ui) -- ./log.can:78
ui:tree("tab", "log", function() -- ./log.can:79
log["level"] = ui:combobox(log["level"] + 3, { -- ./log.can:80
"trace", -- ./log.can:80
"debug", -- ./log.can:80
"info", -- ./log.can:80
"warn", -- ./log.can:80
"error" -- ./log.can:80
}) - 3 -- ./log.can:80
end) -- ./log.can:80
end -- ./log.can:80
} -- ./log.can:80
return log -- ./log.can:85
